var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying an activity indicator.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<ActivityIndicator color="#ce0058" size="large"></ActivityIndicator>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var ActivityIndicator = (function (_super) {
    __extends(ActivityIndicator, _super);
    function ActivityIndicator(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Properties
        _this._animating = true;
        _this._hidesWhenStopped = true;
        _this.setDefaultStyle({ height: 20, width: 20 });
        return _this;
    }
    Object.defineProperty(ActivityIndicator.prototype, "animating", {
        /**
         * To be documented
         */
        set: function (value) { this._animating = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ActivityIndicator.prototype, "color", {
        /**
         * To be documented
         */
        set: function (value) { this._color = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ActivityIndicator.prototype, "hidesWhenStopped", {
        /**
         * To be documented
         */
        set: function (value) { this._hidesWhenStopped = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ActivityIndicator.prototype, "size", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) {
            this._size = this.processEnum(value, ['small', 'large']);
            if (this._size == 'small') {
                this.setDefaultStyle({ height: 20, width: 20 });
            }
            else if (this._size == 'large') {
                this.setDefaultStyle({ height: 36, width: 36 });
            }
            else {
                this.setDefaultStyle({ height: this._size, width: this._size });
            }
        },
        enumerable: true,
        configurable: true
    });
    return ActivityIndicator;
}(HighLevelComponent));
export { ActivityIndicator };
ActivityIndicator.decorators = [
    { type: Component, args: [{
                selector: 'ActivityIndicator',
                inputs: [
                    'animating', 'color', 'hidesWhenStopped', 'size',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-activityindicator [animating]=\"_animating\" [color]=\"_color\" [hidesWhenStopped]=\"_hidesWhenStopped\"\n  [size]=\"_size\" styleAttr=\"Normal\" indeterminate=\"true\" \n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"></native-activityindicator>"
            },] },
];
/** @nocollapse */
ActivityIndicator.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
//# sourceMappingURL=_activity_indicator.js.map