import { ReactNativeWrapper } from "../../wrapper/wrapper";
export declare var GENERIC_INPUTS: Array<string>;
export declare var GENERIC_BINDINGS: string;
/**
 * An abstract component which defines inputs available in all components.
 */
export declare abstract class HighLevelComponent {
    _wrapper: ReactNativeWrapper;
    constructor(_wrapper: ReactNativeWrapper);
    _defaultStyle: {
        [s: string]: any;
    };
    _styleSheet: Array<number | boolean | {
        [s: string]: any;
    }>;
    _style: {
        [s: string]: any;
    };
    /**
     * To be documented
     */
    styleSheet: Array<number | boolean> | number | boolean;
    /**
     * To be documented
     */
    style: {
        [s: string]: any;
    };
    _accessible: boolean;
    _accessibilityLabel: string;
    _testID: string;
    _pointerEvents: string;
    _removeClippedSubviews: boolean;
    _onLayout: boolean;
    /**
     * To be documented
     */
    accessible: any;
    /**
     * To be documented
     */
    accessibilityLabel: string;
    /**
     * To be documented
     */
    testID: string;
    /**
     * To be documented
     */
    pointerEvents: string;
    /**
     * To be documented
     */
    removeClippedSubviews: any;
    /**
     * To be documented
     */
    onLayout: any;
    _collapsable: boolean;
    _accessibilityLiveRegion: string;
    _accessibilityComponentType: string;
    _importantForAccessibility: string;
    _needsOffscreenAlphaCompositing: boolean;
    _renderToHardwareTextureAndroid: boolean;
    _nativeBackgroundAndroid: any;
    /**
     * To be documented
     * @platform android
     */
    collapsable: any;
    /**
     * To be documented
     * @platform android
     */
    accessibilityLiveRegion: string;
    /**
     * To be documented
     * @platform android
     */
    accessibilityComponentType: string;
    /**
     * To be documented
     * @platform android
     */
    importantForAccessibility: string;
    /**
     * To be documented
     * @platform android
     */
    needsOffscreenAlphaCompositing: any;
    /**
     * To be documented
     * @platform android
     */
    renderToHardwareTextureAndroid: any;
    /**
     * To be documented
     * @platform android
     */
    nativeBackgroundAndroid: any;
    _accessibilityTraits: any;
    _shouldRasterizeIOS: boolean;
    /**
     * To be documented
     * @platform ios
     */
    accessibilityTraits: any;
    /**
     * To be documented
     * @platform ios
     */
    shouldRasterizeIOS: any;
    setDefaultStyle(defaultStyle: {
        [s: string]: any;
    }): void;
    processBoolean(value: any): boolean;
    processNumber(value: any): number;
    processColor(color: string): number;
    processEnum<T>(value: T, list: Array<T>): T;
    processDate(value: any): number;
    resolveAssetSource(source: any): any;
    dismissKeyboard(): void;
    getUIManager(): any;
}
