import { EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying local or remote images.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Image [source]="angularLogo"></Image>`
})
export class Sample {
  angularLogo: any = require('./assets/angular.png');
}
 * ```
 * @style https://facebook.github.io/react-native/docs/image.html#style
 */
export declare class Image extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    load: EventEmitter<any>;
    /**
     * To be documented
     */
    loadStart: EventEmitter<any>;
    /**
     * To be documented
     */
    loadEnd: EventEmitter<any>;
    _resizeMode: string;
    _source: any;
    /**
     * To be documented
     */
    resizeMode: string;
    /**
     * To be documented
     */
    source: string;
    _fadeDuration: number;
    _loadingIndicatorSrc: any;
    _progressiveRenderingEnabled: boolean;
    _shouldNotifyLoadEvents: boolean;
    /**
     * To be documented
     * @platform android
     */
    fadeDuration: any;
    /**
     * To be documented
     * @platform android
     */
    loadingIndicatorSrc: any;
    /**
     * To be documented
     * @platform android
     */
    progressiveRenderingEnabled: any;
    /**
     * To be documented
     * @platform android
     */
    shouldNotifyLoadEvents: any;
    _blurRadius: number;
    _capInsets: any;
    _defaultSource: string;
    /**
     * To be documented
     * @platform ios
     */
    blurRadius: string;
    /**
     * To be documented
     * @platform ios
     */
    capInsets: string;
    /**
     * To be documented
     * @platform ios
     */
    defaultSource: string;
    _handleLoad(): void;
    _handleLoadStart(): void;
    _handleLoadEnd(x: number, y: boolean): void;
}
