var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper, isAndroid } from "../../wrapper/wrapper";
var ANDROID_INPUTS = [];
var IOS_INPUTS = ['maximumTrackImage', 'maximumTrackTintColor', 'minimumTrackImage', 'minimumTrackTintColor', 'thumbImage', 'trackImage'];
var ANDROID_BINDINGS = "(topChange)=\"_handleValueChange($event)\"";
var IOS_BINDINGS = "[maximumTrackImage]=\"_maximumTrackImage\" [maximumTrackTintColor]=\"_maximumTrackTintColor\"\n  [minimumTrackImage]=\"_minimumTrackImage\" [minimumTrackTintColor]=\"_minimumTrackTintColor\" [thumbImage]=\"_thumbImage\" [trackImage]=\"_trackImage\"\n  (topValueChange)=\"_handleValueChange($event)\"";
/**
 * A component for displaying a slider.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<Slider value="0.6"></Slider>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var Slider = (function (_super) {
    __extends(Slider, _super);
    function Slider(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.valueChange = new EventEmitter();
        /**
         * To be documented
         */
        _this.slidingComplete = new EventEmitter();
        //Properties
        _this._disabled = false;
        _this._maximumValue = 1;
        _this._minimumValue = 0;
        _this._step = 0;
        if (!wrapper.isAndroid()) {
            _this.setDefaultStyle({ height: 40 });
        }
        return _this;
    }
    Object.defineProperty(Slider.prototype, "disabled", {
        /**
         * To be documented
         */
        set: function (value) { this._disabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "maximumValue", {
        /**
         * To be documented
         */
        set: function (value) { this._maximumValue = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "minimumValue", {
        /**
         * To be documented
         */
        set: function (value) { this._minimumValue = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "step", {
        /**
         * To be documented
         */
        set: function (value) { this._step = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "value", {
        /**
         * To be documented
         */
        set: function (value) { this._value = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "maximumTrackImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._maximumTrackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "maximumTrackTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._maximumTrackTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "minimumTrackImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._minimumTrackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "minimumTrackTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._minimumTrackTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "thumbImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._thumbImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "trackImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._trackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Slider.prototype._handleValueChange = function (event) {
        //Event example: {value: 0.4325, target: 18}
        if (!isAndroid() || event.fromUser) {
            this.valueChange.emit(event.value);
        }
    };
    Slider.prototype._handleSlidingComplete = function (event) {
        //Event example: {value: 0.4325, target: 18}
        this.slidingComplete.emit(event.value);
    };
    return Slider;
}(HighLevelComponent));
export { Slider };
Slider.decorators = [
    { type: Component, args: [{
                selector: 'Slider',
                inputs: ['disabled', 'maximumValue', 'minimumValue', 'step', 'value', 'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style',],
                template: "<native-slider [disabled]=\"_disabled\"  [maximumValue]=\"_maximumValue\" [minimumValue]=\"_minimumValue\" [step]=\"_step\"  [value]=\"_value\"\n  onValueChange=\"true\" onSlidingComplete=\"true\" (topSlidingComplete)=\"_handleSlidingComplete($event)\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" (topChange)=\"_handleValueChange($event)\"></native-slider>"
            },] },
];
/** @nocollapse */
Slider.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
Slider.propDecorators = {
    'valueChange': [{ type: Output },],
    'slidingComplete': [{ type: Output },],
};
//# sourceMappingURL=_slider.js.map