var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./_component";
var ANDROID_INPUTS = [];
var IOS_INPUTS = ['onTintColor', 'thumbTintColor', 'tintColor'];
var ANDROID_BINDINGS = "";
var IOS_BINDINGS = "[_onTintColor]=\"_onTintColor\" [thumbTintColor]=\"_thumbTintColor\" [tintColor]=\"_tintColor\" onChange=\"true\"";
/**
 * A component for displaying a switch.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Switch (change)="switched=$event"></Switch>`
})
export class Sample {
  switched: boolean = false;
 }
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var Switch = (function (_super) {
    __extends(Switch, _super);
    function Switch(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.change = new EventEmitter();
        //Properties
        _this._on = false;
        _this._enabled = true;
        _this.setDefaultStyle({ height: 31, width: 51 });
        return _this;
    }
    Object.defineProperty(Switch.prototype, "on", {
        /**
         * To be documented
         */
        set: function (value) { this._on = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "enabled", {
        /**
         * To be documented
         */
        set: function (value) { this._enabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "onTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._onTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "thumbTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._thumbTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "tintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Switch.prototype._handleChange = function (event) {
        this._on = event.value;
        this.change.emit(this._on);
    };
    return Switch;
}(HighLevelComponent));
export { Switch };
Switch.decorators = [
    { type: Component, args: [{
                selector: 'Switch',
                inputs: [
                    'on', 'enabled',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style',
                ],
                template: "<native-switch [_on]=\"_on\" [enabled]=\"_enabled\"\n  (topChange)=\"_handleChange($event)\" [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" ></native-switch>"
            },] },
];
/** @nocollapse */
Switch.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
Switch.propDecorators = {
    'change': [{ type: Output },],
};
//# sourceMappingURL=_switch.js.map