var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./_component";
var ANDROID_INPUTS = ['selectable'];
var IOS_INPUTS = ['allowFontScaling', 'suppressHighlighting'];
var ANDROID_BINDINGS = "[selectable]=\"_selectable\"";
var IOS_BINDINGS = "[allowFontScaling]=\"_allowFontScaling\" [suppressHighlighting]=\"_suppressHighlighting\"";
/**
 * A component for displaying a text.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Text [style]="{margin: 10}">Horizontal</Text>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/text.html#style
 */
var Text = (function (_super) {
    __extends(Text, _super);
    function Text(wrapper) {
        return _super.call(this, wrapper) || this;
    }
    Object.defineProperty(Text.prototype, "lineBreakMode", {
        /**
         * To be documented
         */
        set: function (value) { this._lineBreakMode = this.processEnum(value, ['tail', 'head', 'middle', 'clip']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "numberOfLines", {
        /**
         * To be documented
         */
        set: function (value) { this._numberOfLines = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "selectable", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._selectable = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "allowFontScaling", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._allowFontScaling = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "suppressHighlighting", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._suppressHighlighting = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    return Text;
}(HighLevelComponent));
export { Text };
Text.decorators = [
    { type: Component, args: [{
                selector: 'Text',
                inputs: [
                    'lineBreakMode', 'numberOfLines',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style', 'selectable'
                ],
                template: "<native-text [lineBreakMode]=\"_lineBreakMode\" [numberOfLines]=\"_numberOfLines\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" [selectable]=\"_selectable\"><ng-content></ng-content></native-text>"
            },] },
];
/** @nocollapse */
Text.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
//# sourceMappingURL=_text.js.map