var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, ElementRef, Inject } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent, GENERIC_INPUTS } from "./_component";
/**
 * A component for displaying a view, the default container.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<View></View>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var View = (function (_super) {
    __extends(View, _super);
    function View(wrapper, el) {
        var _this = _super.call(this, wrapper) || this;
        _this._nativeElement = el.nativeElement;
        return _this;
    }
    //Commands
    /**
     * To be documented
     */
    View.prototype.setPressed = function (isPressed) {
        this._nativeElement.children[0].dispatchCommand('setPressed', [isPressed]);
    };
    /**
     * To be documented
     */
    View.prototype.hotspotUpdate = function (x, y) {
        this._nativeElement.children[0].dispatchCommand('hotspotUpdate', [x || 0, y || 0]);
    };
    return View;
}(HighLevelComponent));
export { View };
View.decorators = [
    { type: Component, args: [{
                selector: 'View',
                inputs: GENERIC_INPUTS,
                template: "<native-view [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"><ng-content></ng-content></native-view>"
            },] },
];
/** @nocollapse */
View.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
//# sourceMappingURL=_view.js.map