import { ElementRef, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
export declare class DrawerLayoutSide {
}
export declare class DrawerLayoutContent {
}
/**
 * A component for displaying a drawer layout.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `
<DrawerLayout drawerWidth="240" drawerPosition="left">
  <DrawerLayoutSide>
    <View></View>
  </DrawerLayoutSide>
  <DrawerLayoutContent>
    <View></View>
  </DrawerLayoutContent>
</DrawerLayout>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
export declare class DrawerLayout extends HighLevelComponent {
    private _nativeElement;
    constructor(wrapper: ReactNativeWrapper, el: ElementRef);
    /**
     * To be documented
     */
    drawerClosed: EventEmitter<any>;
    /**
     * To be documented
     */
    drawerOpened: EventEmitter<any>;
    /**
     * To be documented
     */
    drawerSlide: EventEmitter<any>;
    /**
     * To be documented
     */
    drawerStateChanged: EventEmitter<any>;
    _keyboardDismissMode: string;
    _drawerLockMode: string;
    _drawerPosition: number;
    _drawerWidth: number;
    _statusBarBackgroundColor: number;
    /**
     * To be documented
     */
    keyboardDismissMode: string;
    /**
     * To be documented
     */
    drawerLockMode: string;
    /**
     * To be documented
     */
    drawerPosition: any;
    /**
     * To be documented
     */
    drawerWidth: any;
    /**
     * To be documented
     */
    statusBarBackgroundColor: string;
    _handleDrawerClosed(event: any): void;
    _handleDrawerOpened(event: any): void;
    _handleDrawerSlide(event: any): void;
    _handleDrawerStateChanged(event: any): void;
    /**
     * To be documented
     */
    openDrawer(): void;
    /**
     * To be documented
     */
    closeDrawer(): void;
}
