var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, ElementRef, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
var DrawerLayoutSide = (function () {
    function DrawerLayoutSide() {
    }
    return DrawerLayoutSide;
}());
export { DrawerLayoutSide };
DrawerLayoutSide.decorators = [
    { type: Component, args: [{
                selector: 'DrawerLayoutSide',
                template: "<ng-content></ng-content>"
            },] },
];
/** @nocollapse */
DrawerLayoutSide.ctorParameters = function () { return []; };
var DrawerLayoutContent = (function () {
    function DrawerLayoutContent() {
    }
    return DrawerLayoutContent;
}());
export { DrawerLayoutContent };
DrawerLayoutContent.decorators = [
    { type: Component, args: [{
                selector: 'DrawerLayoutContent',
                template: "<ng-content></ng-content>"
            },] },
];
/** @nocollapse */
DrawerLayoutContent.ctorParameters = function () { return []; };
/**
 * A component for displaying a drawer layout.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `
<DrawerLayout drawerWidth="240" drawerPosition="left">
  <DrawerLayoutSide>
    <View></View>
  </DrawerLayoutSide>
  <DrawerLayoutContent>
    <View></View>
  </DrawerLayoutContent>
</DrawerLayout>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
var DrawerLayout = (function (_super) {
    __extends(DrawerLayout, _super);
    function DrawerLayout(wrapper, el) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.drawerClosed = new EventEmitter();
        /**
         * To be documented
         */
        _this.drawerOpened = new EventEmitter();
        /**
         * To be documented
         */
        _this.drawerSlide = new EventEmitter();
        /**
         * To be documented
         */
        _this.drawerStateChanged = new EventEmitter();
        _this._nativeElement = el.nativeElement;
        return _this;
    }
    Object.defineProperty(DrawerLayout.prototype, "keyboardDismissMode", {
        /**
         * To be documented
         */
        set: function (value) { this._keyboardDismissMode = this.processEnum(value, ['none', 'on-drag']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DrawerLayout.prototype, "drawerLockMode", {
        /**
         * To be documented
         */
        set: function (value) { this._drawerLockMode = this.processEnum(value, ['unlocked', 'locked-closed', 'locked-open']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DrawerLayout.prototype, "drawerPosition", {
        /**
         * To be documented
         */
        set: function (value) {
            this._drawerPosition = value === 'right' ?
                this.getUIManager().AndroidDrawerLayout.Constants.DrawerPosition.Right :
                this.getUIManager().AndroidDrawerLayout.Constants.DrawerPosition.Left;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DrawerLayout.prototype, "drawerWidth", {
        /**
         * To be documented
         */
        set: function (value) { this._drawerWidth = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DrawerLayout.prototype, "statusBarBackgroundColor", {
        /**
         * To be documented
         */
        set: function (value) { this._statusBarBackgroundColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    DrawerLayout.prototype._handleDrawerClosed = function (event) {
        //Event example: {}
        this.drawerClosed.emit(event);
    };
    DrawerLayout.prototype._handleDrawerOpened = function (event) {
        // Event examples: {}
        this.drawerOpened.emit(event);
    };
    DrawerLayout.prototype._handleDrawerSlide = function (event) {
        // Event example: {offset: 0.75}
        this.drawerSlide.emit(event);
        if (this._keyboardDismissMode === 'on-drag') {
            this.dismissKeyboard();
        }
    };
    DrawerLayout.prototype._handleDrawerStateChanged = function (event) {
        // Event examples: {drawerState: 0}, {drawerState: 2}
        this.drawerStateChanged.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    DrawerLayout.prototype.openDrawer = function () {
        this._nativeElement.children[0].dispatchCommand('openDrawer');
    };
    /**
     * To be documented
     */
    DrawerLayout.prototype.closeDrawer = function () {
        this._nativeElement.children[0].dispatchCommand('closeDrawer');
    };
    return DrawerLayout;
}(HighLevelComponent));
export { DrawerLayout };
DrawerLayout.decorators = [
    { type: Component, args: [{
                selector: 'DrawerLayout',
                inputs: [
                    //Non-native
                    'keyboardDismissMode',
                    //Native
                    'drawerLockMode', 'drawerPosition', 'drawerWidth', 'statusBarBackgroundColor',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-drawerlayout [drawerLockMode]=\"_drawerLockMode\" [drawerPosition]=\"_drawerPosition\" [drawerWidth]=\"_drawerWidth\"\n  [statusBarBackgroundColor]=\"_statusBarBackgroundColor\"\n  (topDrawerClosed)=\"_handleDrawerClosed($event)\" (topDrawerOpened)=\"_handleDrawerOpened($event)\"\n  (topDrawerSlide)=\"_handleDrawerSlide($event)\" (topDrawerStateChanged)=\"_handleDrawerStateChanged($event)\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\">\n    <native-view position=\"absolute\" top=\"0\" left=\"0\" right=\"0\" bottom=\"0\" collapsable=\"false\">\n      <ng-content select=\"DrawerLayoutSide\"></ng-content>\n    </native-view>\n    <native-view position=\"absolute\" top=\"0\" bottom=\"0\" [width]=\"_drawerWidth\" collapsable=\"false\">\n      <ng-content select=\"DrawerLayoutContent\"></ng-content>\n    </native-view>\n  </native-drawerlayout>"
            },] },
];
/** @nocollapse */
DrawerLayout.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
DrawerLayout.propDecorators = {
    'drawerClosed': [{ type: Output },],
    'drawerOpened': [{ type: Output },],
    'drawerSlide': [{ type: Output },],
    'drawerStateChanged': [{ type: Output },],
};
//# sourceMappingURL=drawer_layout.js.map