import { ElementRef, EventEmitter, OnInit } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a pager layout.
 *
 * ```
@Component({
  selector: 'sample',
  template: `
<PagerLayout initialPage="0">
  <View></View>
  <View></View>
</PagerLayout>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
export declare class PagerLayout extends HighLevelComponent implements OnInit {
    private _nativeElement;
    constructor(wrapper: ReactNativeWrapper, el: ElementRef);
    /**
     * To be documented
     */
    pageScroll: EventEmitter<any>;
    /**
     * To be documented
     */
    pageScrollStateChanged: EventEmitter<any>;
    /**
     * To be documented
     */
    pageSelected: EventEmitter<any>;
    _initialPage: number;
    _keyboardDismissMode: string;
    _scrollEnabled: boolean;
    /**
     * To be documented
     */
    initialPage: any;
    /**
     * To be documented
     */
    keyboardDismissMode: string;
    /**
     * To be documented
     */
    scrollEnabled: any;
    _handlePageScroll(event: any): void;
    _handlePageScrollStateChanged(event: any): void;
    _handlePageSelected(event: any): void;
    /**
     * To be documented
     */
    setPage(index: number): void;
    /**
     * To be documented
     */
    setPageWithoutAnimation(index: number): void;
    ngOnInit(): void;
}
