var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, ElementRef, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a pager layout.
 *
 * ```
@Component({
  selector: 'sample',
  template: `
<PagerLayout initialPage="0">
  <View></View>
  <View></View>
</PagerLayout>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
var PagerLayout = (function (_super) {
    __extends(PagerLayout, _super);
    function PagerLayout(wrapper, el) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.pageScroll = new EventEmitter();
        /**
         * To be documented
         */
        _this.pageScrollStateChanged = new EventEmitter();
        /**
         * To be documented
         */
        _this.pageSelected = new EventEmitter();
        _this._nativeElement = el.nativeElement;
        return _this;
    }
    Object.defineProperty(PagerLayout.prototype, "initialPage", {
        /**
         * To be documented
         */
        set: function (value) { this._initialPage = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagerLayout.prototype, "keyboardDismissMode", {
        /**
         * To be documented
         */
        set: function (value) { this._keyboardDismissMode = this.processEnum(value, ['none', 'on-drag']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PagerLayout.prototype, "scrollEnabled", {
        /**
         * To be documented
         */
        set: function (value) { this._scrollEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    PagerLayout.prototype._handlePageScroll = function (event) {
        //Event example: {offset: 0.75, position: 0}
        this.pageScroll.emit(event);
        if (this._keyboardDismissMode === 'on-drag') {
            this.dismissKeyboard();
        }
    };
    PagerLayout.prototype._handlePageScrollStateChanged = function (event) {
        // Event examples: {pageScrollState: "idle"}, {pageScrollState: "dragging"}, {pageScrollState: "settling"}
        this.pageScrollStateChanged.emit(event);
    };
    PagerLayout.prototype._handlePageSelected = function (event) {
        // Event example: {position: 1}
        this.pageSelected.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    PagerLayout.prototype.setPage = function (index) {
        this._nativeElement.children[0].dispatchCommand('setPage', [index]);
    };
    /**
     * To be documented
     */
    PagerLayout.prototype.setPageWithoutAnimation = function (index) {
        this._nativeElement.children[0].dispatchCommand('setPageWithoutAnimation', [index]);
    };
    //Lifecycle
    PagerLayout.prototype.ngOnInit = function () {
        var _this = this;
        if (this._initialPage) {
            setTimeout(function () {
                _this.setPageWithoutAnimation(_this._initialPage);
            }, 0);
        }
    };
    return PagerLayout;
}(HighLevelComponent));
export { PagerLayout };
PagerLayout.decorators = [
    { type: Component, args: [{
                selector: 'PagerLayout',
                inputs: [
                    //Non-native
                    'initialPage', 'keyboardDismissMode',
                    //Native
                    'scrollEnabled',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-pagerlayout [scrollEnabled]=\"_scrollEnabled\"\n  (topPageScroll)=\"_handlePageScroll($event)\" (topPageScrollStateChanged)=\"_handlePageScrollStateChanged($event)\" (topPageSelected)=\"_handlePageSelected($event)\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"><ng-content></ng-content></native-pagerlayout>"
            },] },
];
/** @nocollapse */
PagerLayout.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
PagerLayout.propDecorators = {
    'pageScroll': [{ type: Output },],
    'pageScrollStateChanged': [{ type: Output },],
    'pageSelected': [{ type: Output },],
};
//# sourceMappingURL=pager_layout.js.map