var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a progress bar.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<ProgressBar styleAttr="Large"></ProgressBar>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
var ProgressBar = (function (_super) {
    __extends(ProgressBar, _super);
    function ProgressBar(wrapper) {
        return _super.call(this, wrapper) || this;
    }
    Object.defineProperty(ProgressBar.prototype, "color", {
        /**
         * To be documented
         */
        set: function (value) { this._color = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBar.prototype, "indeterminate", {
        /**
         * To be documented
         */
        set: function (value) { this._indeterminate = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBar.prototype, "progress", {
        /**
         * To be documented
         */
        set: function (value) { this._progress = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBar.prototype, "styleAttr", {
        /**
         * To be documented
         */
        set: function (value) { this._styleAttr = this.processEnum(value, ['Normal', 'Horizontal', 'Small', 'Large', 'Inverse', 'SmallInverse', 'LargeInverse']); },
        enumerable: true,
        configurable: true
    });
    return ProgressBar;
}(HighLevelComponent));
export { ProgressBar };
ProgressBar.decorators = [
    { type: Component, args: [{
                selector: 'ProgressBar',
                inputs: [
                    'color', 'indeterminate', 'progress', 'styleAttr',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-progressbar [color]=\"_color\" [indeterminate]=\"_indeterminate\" [progress]=\"_progress\" [styleAttr]=\"_styleAttr\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"></native-progressbar>"
            },] },
];
/** @nocollapse */
ProgressBar.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
//# sourceMappingURL=progress_bar.js.map