import { EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a toolbar.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Toolbar [styleSheet]="styles.toolbar" [navIcon]="hamburgerIcon" [overflowIcon]="moreIcon"
    title="Kitchen Sink" titleColor="#FFFFFF" (select)="handleToolbar($event)"></Toolbar>`
})
export class Sample {
  hamburgerIcon: any = require('../../assets/icon_hamburger.png');
  moreIcon: any = require('../../assets/icon_more.png');
 }
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
export declare class Toolbar extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    select: EventEmitter<any>;
    _actions: Array<any>;
    _contentInsetStart: number;
    _contentInsetEnd: number;
    _logo: any;
    _navIcon: any;
    _overflowIcon: any;
    _rtl: boolean;
    _subtitle: string;
    _subtitleColor: number;
    _title: string;
    _titleColor: number;
    /**
     * To be documented
     */
    actions: Array<any>;
    /**
     * To be documented
     */
    contentInsetStart: any;
    /**
     * To be documented
     */
    contentInsetEnd: any;
    /**
     * To be documented
     */
    logo: any;
    /**
     * To be documented
     */
    navIcon: any;
    /**
     * To be documented
     */
    overflowIcon: any;
    /**
     * To be documented
     */
    rtl: string;
    /**
     * To be documented
     */
    subtitle: string;
    /**
     * To be documented
     */
    subtitleColor: any;
    /**
     * To be documented
     */
    title: string;
    /**
     * To be documented
     */
    titleColor: any;
    _handleSelect(event: any): void;
}
