var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a toolbar.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Toolbar [styleSheet]="styles.toolbar" [navIcon]="hamburgerIcon" [overflowIcon]="moreIcon"
    title="Kitchen Sink" titleColor="#FFFFFF" (select)="handleToolbar($event)"></Toolbar>`
})
export class Sample {
  hamburgerIcon: any = require('../../assets/icon_hamburger.png');
  moreIcon: any = require('../../assets/icon_more.png');
 }
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform android
 */
var Toolbar = (function (_super) {
    __extends(Toolbar, _super);
    function Toolbar(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.select = new EventEmitter();
        _this._subtitle = null;
        return _this;
    }
    Object.defineProperty(Toolbar.prototype, "actions", {
        /**
         * To be documented
         */
        set: function (value) {
            var _this = this;
            this._actions = value.map(function (action) {
                var result = {};
                if (typeof action.title != 'undefined') {
                    result['title'] = action.title;
                }
                if (typeof action.icon != 'undefined') {
                    result['icon'] = _this.resolveAssetSource(action.icon);
                }
                result['show'] = _this.getUIManager().ToolbarAndroid.Constants.ShowAsAction[action.show] || 0;
                if (typeof action.icon != 'undefined') {
                    result['showWithText'] = action.showWithText;
                }
                return result;
            });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "contentInsetStart", {
        /**
         * To be documented
         */
        set: function (value) { this._contentInsetStart = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "contentInsetEnd", {
        /**
         * To be documented
         */
        set: function (value) { this._contentInsetEnd = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "logo", {
        /**
         * To be documented
         */
        set: function (value) { this._logo = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "navIcon", {
        /**
         * To be documented
         */
        set: function (value) { this._navIcon = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "overflowIcon", {
        /**
         * To be documented
         */
        set: function (value) { this._overflowIcon = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "rtl", {
        /**
         * To be documented
         */
        set: function (value) { this._rtl = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "subtitle", {
        /**
         * To be documented
         */
        set: function (value) { this._subtitle = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "subtitleColor", {
        /**
         * To be documented
         */
        set: function (value) { this._subtitleColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "title", {
        /**
         * To be documented
         */
        set: function (value) { this._title = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Toolbar.prototype, "titleColor", {
        /**
         * To be documented
         */
        set: function (value) { this._titleColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Toolbar.prototype._handleSelect = function (event) {
        // Event examples: {position: -1}
        this.select.emit(event);
    };
    return Toolbar;
}(HighLevelComponent));
export { Toolbar };
Toolbar.decorators = [
    { type: Component, args: [{
                selector: 'Toolbar',
                inputs: [
                    'actions', 'contentInsetStart', 'contentInsetEnd', 'logo', 'navIcon', 'overflowIcon', 'rtl', 'subtitle', 'subtitleColor', 'title', 'titleColor',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-toolbar [nativeActions]=\"_actions\" [contentInsetStart]=\"_contentInsetStart\" [contentInsetEnd]=\"_contentInsetEnd\" [logo]=\"_logo\"\n  [navIcon]=\"_navIcon\" [overflowIcon]=\"_overflowIcon\" [rtl]=\"_rtl\" [subtitle]=\"_subtitle\" [subtitleColor]=\"_subtitleColor\" [title]=\"_title\" [titleColor]=\"_titleColor\"\n  (topSelect)=\"_handleSelect($event)\" [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"></native-toolbar>"
            },] },
];
/** @nocollapse */
Toolbar.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
Toolbar.propDecorators = {
    'select': [{ type: Output },],
};
//# sourceMappingURL=toolbar.js.map