import { HighLevelComponent } from "./component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying an activity indicator.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<ActivityIndicator color="#ce0058" size="large"></ActivityIndicator>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class ActivityIndicator extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    _animating: boolean;
    _color: number;
    _hidesWhenStopped: boolean;
    _size: string | number;
    /**
     * To be documented
     */
    animating: string;
    /**
     * To be documented
     */
    color: string;
    /**
     * To be documented
     */
    hidesWhenStopped: any;
    /**
     * To be documented
     * @platform ios
     */
    size: string | number;
}
