"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var component_1 = require("./component");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
/**
 * A component for displaying an activity indicator.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<ActivityIndicator color="#ce0058" size="large"></ActivityIndicator>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var ActivityIndicator = (function (_super) {
    __extends(ActivityIndicator, _super);
    function ActivityIndicator(wrapper) {
        _super.call(this, wrapper);
        //Properties
        this._animating = true;
        this._hidesWhenStopped = true;
        this.setDefaultStyle({ height: 20, width: 20 });
    }
    Object.defineProperty(ActivityIndicator.prototype, "animating", {
        /**
         * To be documented
         */
        set: function (value) { this._animating = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ActivityIndicator.prototype, "color", {
        /**
         * To be documented
         */
        set: function (value) { this._color = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ActivityIndicator.prototype, "hidesWhenStopped", {
        /**
         * To be documented
         */
        set: function (value) { this._hidesWhenStopped = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ActivityIndicator.prototype, "size", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) {
            this._size = this.processEnum(value, ['small', 'large']);
            if (this._size == 'small') {
                this.setDefaultStyle({ height: 20, width: 20 });
            }
            else if (this._size == 'large') {
                this.setDefaultStyle({ height: 36, width: 36 });
            }
            else {
                this.setDefaultStyle({ height: this._size, width: this._size });
            }
        },
        enumerable: true,
        configurable: true
    });
    ActivityIndicator = __decorate([
        core_1.Component({
            selector: 'ActivityIndicator',
            inputs: [
                'animating', 'color', 'hidesWhenStopped', 'size'
            ].concat(component_1.GENERIC_INPUTS),
            template: "<native-activityindicator [animating]=\"_animating\" [color]=\"_color\" [hidesWhenStopped]=\"_hidesWhenStopped\"\n  [size]=\"_size\" " + (wrapper_1.isAndroid() ? 'styleAttr="Normal" indeterminate="true"' : '') + " \n  " + component_1.GENERIC_BINDINGS + "></native-activityindicator>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper])
    ], ActivityIndicator);
    return ActivityIndicator;
}(component_1.HighLevelComponent));
exports.ActivityIndicator = ActivityIndicator;
