"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var component_1 = require("./component");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var ANDROID_INPUTS = ['fadeDuration', 'loadingIndicatorSrc', 'progressiveRenderingEnabled', 'shouldNotifyLoadEvents'];
var IOS_INPUTS = ['blurRadius', 'capInsets', 'defaultSource'];
var ANDROID_BINDINGS = "[fadeDuration]=\"_fadeDuration\" [loadingIndicatorSrc]=\"_loadingIndicatorSrc ? _loadingIndicatorSrc.uri : null\"\n  [progressiveRenderingEnabled]=\"_progressiveRenderingEnabled\" [shouldNotifyLoadEvents]=\"_shouldNotifyLoadEvents\" [src]=\"_source ? [{uri: _source.uri}] : null\"";
var IOS_BINDINGS = "[blurRadius]=\"_blurRadius\" [capInsets]=\"_capInsets\" [defaultSource]=\"_defaultSource\" [source]=\"[_source]\"";
//TODO: add iOS specific events (onError, on Progress) and specific cases (tintColor, resizeMode)
/**
 * A component for displaying local or remote images.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Image [source]="angularLogo"></Image>`
})
export class Sample {
  angularLogo: any = require('./assets/angular.png');
}
 * ```
 * @style https://facebook.github.io/react-native/docs/image.html#style
 */
var Image = (function (_super) {
    __extends(Image, _super);
    function Image(wrapper) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.load = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.loadStart = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.loadEnd = new core_1.EventEmitter();
    }
    Object.defineProperty(Image.prototype, "resizeMode", {
        /**
         * To be documented
         */
        set: function (value) { this._resizeMode = this.processEnum(value, ['cover', 'contain', 'stretch', 'repeat', 'center']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "source", {
        /**
         * To be documented
         */
        set: function (value) { this._source = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "fadeDuration", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._fadeDuration = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "loadingIndicatorSrc", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._loadingIndicatorSrc = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "progressiveRenderingEnabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._progressiveRenderingEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "shouldNotifyLoadEvents", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._shouldNotifyLoadEvents = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "blurRadius", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._blurRadius = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "capInsets", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._capInsets = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "defaultSource", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._defaultSource = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    Image.prototype._handleLoad = function () {
        this.load.emit(null);
    };
    Image.prototype._handleLoadStart = function () {
        this.loadStart.emit(null);
    };
    Image.prototype._handleLoadEnd = function (x, y) {
        this.loadEnd.emit(null);
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Image.prototype, "load", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Image.prototype, "loadStart", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Image.prototype, "loadEnd", void 0);
    Image = __decorate([
        core_1.Component({
            selector: 'Image',
            inputs: [
                'resizeMode', 'source'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-image  [resizeMode]=\"_resizeMode\"\n  (topLoad)=\"_handleLoad()\" (topLoadStart)=\"_handleLoadStart()\" (topLoadEnd)=\"_handleLoadEnd()\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "><ng-content></ng-content></native-image>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper])
    ], Image);
    return Image;
}(component_1.HighLevelComponent));
exports.Image = Image;
