import { EventEmitter } from "@angular/core";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./component";
/**
 * A component for displaying a picker.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Picker [selectedValue]="selected" prompt="Please select an item" [items]="items"
    [style]="{width: 80}" (select)="selected=$event"></Picker>`
})
export class Sample {
  selected: number = 0;
  items: Array<any> = [{label: 'aaa', value: 'a'}, {label: 'bbb', value: 'b'}, {label: 'ccc', value: 'c'},
    {label: 'ddd', value: 'd'}, {label: 'eee', value: 'e'}];
}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class Picker extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    select: EventEmitter<number>;
    _items: Array<any>;
    _selectedValue: any;
    /**
     * To be documented
     */
    selectedValue: string;
    /**
     * To be documented
     */
    items: Array<any>;
    _enabled: boolean;
    _mode: string;
    _prompt: string;
    /**
     * To be documented
     * @platform android
     */
    enabled: any;
    /**
     * To be documented
     * @platform android
     */
    mode: string;
    /**
     * To be documented
     * @platform android
     */
    prompt: string;
    private _itemStyle;
    /**
     * To be documented
     * @platform ios
     */
    itemStyle: string;
    _handleSelect(event: any): void;
}
