import { EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a refresh control.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<RefreshControl progressBackgroundColor="#ce0058" [colors]="['#00a9e0', '#309712']">
      <View></View>
    </RefreshControl>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class RefreshControl extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    refresh: EventEmitter<any>;
    _refreshing: boolean;
    /**
     * To be documented
     */
    refreshing: string;
    _colors: Array<number>;
    _enabled: boolean;
    _progressBackgroundColor: number;
    _progressViewOffset: number;
    _size: number;
    /**
     * To be documented
     * @platform android
     */
    colors: string | Array<string>;
    /**
     * To be documented
     * @platform android
     */
    enabled: any;
    /**
     * To be documented
     * @platform android
     */
    progressBackgroundColor: string;
    /**
     * To be documented
     * @platform android
     */
    progressViewOffset: any;
    /**
     * To be documented
     * @platform android
     */
    size: any;
    _tintColor: number;
    _title: string;
    /**
     * To be documented
     * @platform ios
     */
    tintColor: string;
    /**
     * To be documented
     * @platform ios
     */
    title: string;
    _handleRefresh(event: any): void;
}
