"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var component_1 = require("./component");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var ANDROID_INPUTS = ['colors', 'enabled', 'progressBackgroundColor', 'progressViewOffset', 'size'];
var IOS_INPUTS = ['tintColor', 'title'];
var ANDROID_BINDINGS = "[colors]=\"_colors\" [enabled]=\"_enabled\" [progressBackgroundColor]=\"_progressBackgroundColor\"\n  [progressViewOffset]=\"_progressViewOffset\" [size]=\"_size\"";
var IOS_BINDINGS = "[tintColor]=\"_tintColor\" [title]=\"_title\" onRefresh=\"true\"";
/**
 * A component for displaying a refresh control.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<RefreshControl progressBackgroundColor="#ce0058" [colors]="['#00a9e0', '#309712']">
      <View></View>
    </RefreshControl>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var RefreshControl = (function (_super) {
    __extends(RefreshControl, _super);
    function RefreshControl(wrapper) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.refresh = new core_1.EventEmitter();
    }
    Object.defineProperty(RefreshControl.prototype, "refreshing", {
        /**
         * To be documented
         */
        set: function (value) { this._refreshing = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "colors", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) {
            var _this = this;
            if (Array.isArray(value)) {
                this._colors = value.map(function (v) { return _this.processColor(v); });
            }
            else {
                this._colors = [this.processColor(value)];
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "enabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._enabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "progressBackgroundColor", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._progressBackgroundColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "progressViewOffset", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._progressViewOffset = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "size", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) {
            this._size = value === 'default' ?
                this.getUIManager().AndroidSwipeRefreshLayout.Constants.SIZE.DEFAULT :
                this.getUIManager().AndroidSwipeRefreshLayout.Constants.SIZE.LARGE;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "tintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "title", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._title = value; },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    RefreshControl.prototype._handleRefresh = function (event) {
        //Event example: null
        this.refresh.emit(null);
        event.target.setProperty('refreshing', !!this._refreshing);
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], RefreshControl.prototype, "refresh", void 0);
    RefreshControl = __decorate([
        core_1.Component({
            selector: 'RefreshControl',
            inputs: [
                'refreshing'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-refreshcontrol  [refreshing]=\"_refreshing\"\n  (topRefresh)=\"_handleRefresh($event)\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "><ng-content></ng-content></native-refreshcontrol>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper])
    ], RefreshControl);
    return RefreshControl;
}(component_1.HighLevelComponent));
exports.RefreshControl = RefreshControl;
