import { EventEmitter, ElementRef } from "@angular/core";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./component";
/**
 * A component for displaying a scrollview.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<ScrollView horizontal="true">
      <View></View>
      <View></View>
    </ScrollView>`
})
export class Sample {}
 * ```
 *
 * TODO: document usage of RefreshControl on Android and iOS
 *
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class ScrollView extends HighLevelComponent {
    private _nativeElement;
    constructor(wrapper: ReactNativeWrapper, el: ElementRef);
    /**
     * To be documented
     */
    scroll: EventEmitter<any>;
    /**
     * To be documented
     */
    scrollBeginDrag: EventEmitter<any>;
    /**
     * To be documented
     */
    scrollEndDrag: EventEmitter<any>;
    /**
     * To be documented
     */
    momentumScrollBegin: EventEmitter<any>;
    /**
     * To be documented
     */
    momentumScrollEnd: EventEmitter<any>;
    _contentContainerStyle: any;
    _horizontal: boolean;
    _keyboardDismissMode: string;
    _keyboardShouldPersistTaps: boolean;
    _pagingEnabled: boolean;
    _scrollEnabled: boolean;
    _sendMomentumEvents: boolean;
    _showsHorizontalScrollIndicator: boolean;
    _showsVerticalScrollIndicator: boolean;
    /**
     * To be documented
     */
    contentContainerStyle: any;
    /**
     * To be documented
     */
    horizontal: any;
    /**
     * To be documented
     */
    keyboardDismissMode: any;
    /**
     * To be documented
     */
    keyboardShouldPersistTaps: any;
    /**
     * To be documented
     */
    pagingEnabled: any;
    /**
     * To be documented
     */
    scrollEnabled: any;
    /**
     * To be documented
     */
    sendMomentumEvents: any;
    /**
     * To be documented
     */
    showsHorizontalScrollIndicator: any;
    /**
     * To be documented
     */
    showsVerticalScrollIndicator: any;
    _endFillColor: number;
    /**
     * To be documented
     * @platform android
     */
    endFillColor: string;
    _alwaysBounceHorizontal: boolean;
    _alwaysBounceVertical: boolean;
    _automaticallyAdjustContentInsets: boolean;
    _bounces: boolean;
    _bouncesZoom: boolean;
    _canCancelContentTouches: boolean;
    _centerContent: boolean;
    _contentInset: any;
    _contentOffset: any;
    _decelerationRate: number;
    _directionalLockEnabled: boolean;
    _indicatorStyle: string;
    _maximumZoomScale: number;
    _minimumZoomScale: number;
    _scrollEventThrottle: number;
    _scrollIndicatorInsets: any;
    _scrollsToTop: boolean;
    _snapToAlignment: string;
    _snapToInterval: number;
    _stickyHeaderIndices: Array<number>;
    _zoomScale: number;
    /**
     * To be documented
     * @platform ios
     */
    alwaysBounceHorizontal: any;
    /**
     * To be documented
     * @platform ios
     */
    alwaysBounceVertical: any;
    /**
     * To be documented
     * @platform ios
     */
    automaticallyAdjustContentInsets: any;
    /**
     * To be documented
     * @platform ios
     */
    bounces: any;
    /**
     * To be documented
     * @platform ios
     */
    bouncesZoom: any;
    /**
     * To be documented
     * @platform ios
     */
    canCancelContentTouches: any;
    /**
     * To be documented
     * @platform ios
     */
    centerContent: any;
    /**
     * To be documented
     * @platform ios
     */
    contentInset: any;
    /**
     * To be documented
     * @platform ios
     */
    contentOffset: any;
    /**
     * To be documented
     * @platform ios
     */
    decelerationRate: string | number;
    /**
     * To be documented
     * @platform ios
     */
    directionalLockEnabled: any;
    /**
     * To be documented
     * @platform ios
     */
    indicatorStyle: string;
    /**
     * To be documented
     * @platform ios
     */
    maximumZoomScale: any;
    /**
     * To be documented
     * @platform ios
     */
    minimumZoomScale: any;
    /**
     * To be documented
     * @platform ios
     */
    scrollEventThrottle: any;
    /**
     * To be documented
     * @platform ios
     */
    scrollIndicatorInsets: any;
    /**
     * To be documented
     * @platform ios
     */
    scrollsToTop: any;
    /**
     * To be documented
     * @platform ios
     */
    snapToAlignment: any;
    /**
     * To be documented
     * @platform ios
     */
    snapToInterval: any;
    /**
     * To be documented
     * @platform ios
     */
    stickyHeaderIndices: Array<number>;
    /**
     * To be documented
     * @platform ios
     */
    zoomScale: any;
    _handleScroll(event: any): void;
    _handleScrollBeginDrag(event: any): void;
    _handleScrollEndDrag(event: any): void;
    _handleMomentumScrollBegin(event: any): void;
    _handleMomentumScrollEnd(event: any): void;
    /**
     * To be documented
     */
    scrollTo(x: number): void;
    /**
     * To be documented
     */
    scrollWithoutAnimationTo(x: number): void;
}
