"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var component_1 = require("./component");
var ANDROID_INPUTS = ['endFillColor'];
var IOS_INPUTS = ['alwaysBounceHorizontal', 'alwaysBounceVertical', 'automaticallyAdjustContentInsets', 'bounces', 'bouncesZoom',
    'canCancelContentTouches', 'centerContent', 'contentInset', 'contentOffset', 'decelerationRate', 'directionalLockEnabled',
    'indicatorStyle', 'maximumZoomScale', 'minimumZoomScale', 'scrollEventThrottle', 'scrollIndicatorInsets',
    'scrollsToTop', 'snapToAlignment', 'snapToInterval', 'stickyHeaderIndices', 'zoomScale'];
var ANDROID_BINDINGS = "[endFillColor]=\"_endFillColor\"";
var IOS_BINDINGS = "[alwaysBounceHorizontal]=\"_alwaysBounceHorizontal\" [alwaysBounceVertical]=\"_alwaysBounceVertical\"\n  [automaticallyAdjustContentInsets]=\"_automaticallyAdjustContentInsets\" [bounces]=\"_bounces\" [bouncesZoom]=\"_bouncesZoom\"\n  [canCancelContentTouches]=\"_canCancelContentTouches\" [centerContent]=\"_centerContent\" [contentInset]=\"_contentInset\"\n  [contentOffset]=\"_contentOffset\" [decelerationRate]=\"_decelerationRate\" [directionalLockEnabled]=\"_directionalLockEnabled\"\n  [indicatorStyle]=\"_indicatorStyle\" [maximumZoomScale]=\"_maximumZoomScale\" [minimumZoomScale]=\"_minimumZoomScale\"\n  [scrollEventThrottle]=\"_scrollEventThrottle\" [scrollIndicatorInsets]=\"_scrollIndicatorInsets\" [scrollsToTop]=\"_scrollsToTop\"\n  [snapToAlignment]=\"_snapToAlignment\" [snapToInterval]=\"_snapToInterval\" [stickyHeaderIndices]=\"_stickyHeaderIndices\" [zoomScale]=\"_zoomScale\"";
//TODO: refreshControl, onContentSizeChange, onScrollAnimationEnd
/**
 * A component for displaying a scrollview.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<ScrollView horizontal="true">
      <View></View>
      <View></View>
    </ScrollView>`
})
export class Sample {}
 * ```
 *
 * TODO: document usage of RefreshControl on Android and iOS
 *
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var ScrollView = (function (_super) {
    __extends(ScrollView, _super);
    function ScrollView(wrapper, el) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.scroll = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.scrollBeginDrag = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.scrollEndDrag = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.momentumScrollBegin = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.momentumScrollEnd = new core_1.EventEmitter();
        this.setDefaultStyle({ overflow: 'scroll' });
        this._nativeElement = el.nativeElement;
    }
    Object.defineProperty(ScrollView.prototype, "contentContainerStyle", {
        /**
         * To be documented
         */
        set: function (value) { this._contentContainerStyle = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "horizontal", {
        /**
         * To be documented
         */
        set: function (value) { this._horizontal = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "keyboardDismissMode", {
        /**
         * To be documented
         */
        set: function (value) { this._keyboardDismissMode = this.processEnum(value, ['none', 'on-drag', 'interactive']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "keyboardShouldPersistTaps", {
        /**
         * To be documented
         */
        set: function (value) { this._keyboardShouldPersistTaps = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "pagingEnabled", {
        /**
         * To be documented
         */
        set: function (value) { this._pagingEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollEnabled", {
        /**
         * To be documented
         */
        set: function (value) { this._scrollEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "sendMomentumEvents", {
        /**
         * To be documented
         */
        set: function (value) { this._sendMomentumEvents = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "showsHorizontalScrollIndicator", {
        /**
         * To be documented
         */
        set: function (value) { this._showsHorizontalScrollIndicator = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "showsVerticalScrollIndicator", {
        /**
         * To be documented
         */
        set: function (value) { this._showsVerticalScrollIndicator = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "endFillColor", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._endFillColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "alwaysBounceHorizontal", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._alwaysBounceHorizontal = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "alwaysBounceVertical", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._alwaysBounceVertical = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "automaticallyAdjustContentInsets", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._automaticallyAdjustContentInsets = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "bounces", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._bounces = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "bouncesZoom", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._bouncesZoom = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "canCancelContentTouches", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._canCancelContentTouches = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "centerContent", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._centerContent = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "contentInset", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._contentInset = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "contentOffset", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._contentOffset = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "decelerationRate", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) {
            if (value === 'normal') {
                this.getUIManager().RCTScrollView.Constants.DecelerationRate.normal;
            }
            else if (value === 'fast') {
                this.getUIManager().RCTScrollView.Constants.DecelerationRate.fast;
            }
            else {
                this._decelerationRate = this.processNumber(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "directionalLockEnabled", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._directionalLockEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "indicatorStyle", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._indicatorStyle = this.processEnum(value, ['default', 'black', 'white',]); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "maximumZoomScale", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._maximumZoomScale = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "minimumZoomScale", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._minimumZoomScale = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollEventThrottle", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollEventThrottle = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollIndicatorInsets", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollIndicatorInsets = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollsToTop", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollsToTop = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "snapToAlignment", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._snapToAlignment = this.processEnum(value, ['start', 'center', 'end']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "snapToInterval", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._snapToInterval = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "stickyHeaderIndices", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._stickyHeaderIndices = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "zoomScale", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._zoomScale = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    ScrollView.prototype._handleScroll = function (event) {
        // Event example:
        // {responderIgnoreScroll: true, layoutMeasurement: {height: 150, width: 400}, contentSize: {height: 150, width: 1200},
        // contentOffset: {x: 399.3, y: 0}, contentInset: {bottom: 0, left: 0, right: 0, top: 0}}
        this.scroll.emit(event);
    };
    ScrollView.prototype._handleScrollBeginDrag = function (event) {
        //Event example: see above
        this.scrollBeginDrag.emit(event);
    };
    ScrollView.prototype._handleScrollEndDrag = function (event) {
        //Event example: see above
        this.scrollEndDrag.emit(event);
    };
    ScrollView.prototype._handleMomentumScrollBegin = function (event) {
        //Event example: see above
        this.momentumScrollBegin.emit(event);
    };
    ScrollView.prototype._handleMomentumScrollEnd = function (event) {
        //Event example: see above
        this.momentumScrollEnd.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    ScrollView.prototype.scrollTo = function (x) {
        this._nativeElement.children[1].dispatchCommand('scrollTo', [x]);
    };
    /**
     * To be documented
     */
    ScrollView.prototype.scrollWithoutAnimationTo = function (x) {
        this._nativeElement.children[1].dispatchCommand('scrollWithoutAnimationTo', [x]);
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ScrollView.prototype, "scroll", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ScrollView.prototype, "scrollBeginDrag", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ScrollView.prototype, "scrollEndDrag", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ScrollView.prototype, "momentumScrollBegin", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], ScrollView.prototype, "momentumScrollEnd", void 0);
    ScrollView = __decorate([
        core_1.Component({
            selector: 'ScrollView',
            inputs: [
                'contentContainerStyle', 'horizontal', 'keyboardDismissMode', 'keyboardShouldPersistTaps', 'pagingEnabled', 'scrollEnabled',
                'sendMomentumEvents', 'showsHorizontalScrollIndicator', 'showsVerticalScrollIndicator'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "\n  <native-scrollview [horizontal]=\"_horizontal\" [keyboardDismissMode]=\"_keyboardDismissMode\" [keyboardShouldPersistTaps]=\"_keyboardShouldPersistTaps\"\n  [pagingEnabled]=\"_pagingEnabled\" [scrollEnabled]=\"_scrollEnabled\" [sendMomentumEvents]=\"_sendMomentumEvents\"\n  [showsHorizontalScrollIndicator]=\"_showsHorizontalScrollIndicator\" [showsVerticalScrollIndicator]=\"_showsVerticalScrollIndicator\"\n  (topScroll)=\"_handleScroll($event)\" (topScrollBeginDrag)=\"_handleScrollBeginDrag($event)\" (topScrollEndDrag)=\"_handleScrollEndDrag($event)\"\n  (topMomentumScrollBegin)=\"_handleMomentumScrollBegin($event)\" (topMomentumScrollEnd)=\"_handleMomentumScrollEnd($event)\"\n  [flexDirection]=\"_horizontal ? 'row' : 'column'\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + ">\n  " + (wrapper_1.isAndroid() ? '' : '<ng-content select="RefreshControl"></ng-content>') + "\n  <native-view [removeClippedSubviews]=\"_removeClippedSubviews\" [style]=\"_contentContainerStyle\" collapsable=\"false\"\n    [flexDirection]=\"_horizontal ? 'row' : null\">\n  <ng-content></ng-content></native-view>\n  </native-scrollview>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper, core_1.ElementRef])
    ], ScrollView);
    return ScrollView;
}(component_1.HighLevelComponent));
exports.ScrollView = ScrollView;
