import { EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a slider.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<Slider value="0.6"></Slider>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class Slider extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    valueChange: EventEmitter<number>;
    /**
     * To be documented
     */
    slidingComplete: EventEmitter<number>;
    _disabled: boolean;
    _maximumValue: number;
    _minimumValue: number;
    _step: number;
    _value: number;
    /**
     * To be documented
     */
    disabled: any;
    /**
     * To be documented
     */
    maximumValue: string;
    /**
     * To be documented
     */
    minimumValue: string;
    /**
     * To be documented
     */
    step: any;
    /**
     * To be documented
     */
    value: any;
    _maximumTrackImage: any;
    _maximumTrackTintColor: number;
    _minimumTrackImage: any;
    _minimumTrackTintColor: number;
    _thumbImage: any;
    _trackImage: any;
    /**
     * To be documented
     * @platform ios
     */
    maximumTrackImage: any;
    /**
     * To be documented
     * @platform ios
     */
    maximumTrackTintColor: string;
    /**
     * To be documented
     * @platform ios
     */
    minimumTrackImage: any;
    /**
     * To be documented
     * @platform ios
     */
    minimumTrackTintColor: string;
    /**
     * To be documented
     * @platform ios
     */
    thumbImage: any;
    /**
     * To be documented
     * @platform ios
     */
    trackImage: any;
    _handleValueChange(event: any): void;
    _handleSlidingComplete(event: any): void;
}
