"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var component_1 = require("./component");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var ANDROID_INPUTS = [];
var IOS_INPUTS = ['maximumTrackImage', 'maximumTrackTintColor', 'minimumTrackImage', 'minimumTrackTintColor', 'thumbImage', 'trackImage'];
var ANDROID_BINDINGS = "(topChange)=\"_handleValueChange($event)\"";
var IOS_BINDINGS = "[maximumTrackImage]=\"_maximumTrackImage\" [maximumTrackTintColor]=\"_maximumTrackTintColor\"\n  [minimumTrackImage]=\"_minimumTrackImage\" [minimumTrackTintColor]=\"_minimumTrackTintColor\" [thumbImage]=\"_thumbImage\" [trackImage]=\"_trackImage\"\n  (topValueChange)=\"_handleValueChange($event)\"";
/**
 * A component for displaying a slider.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<Slider value="0.6"></Slider>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var Slider = (function (_super) {
    __extends(Slider, _super);
    function Slider(wrapper) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.valueChange = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.slidingComplete = new core_1.EventEmitter();
        //Properties
        this._disabled = false;
        this._maximumValue = 1;
        this._minimumValue = 0;
        this._step = 0;
        if (!wrapper.isAndroid()) {
            this.setDefaultStyle({ height: 40 });
        }
    }
    Object.defineProperty(Slider.prototype, "disabled", {
        /**
         * To be documented
         */
        set: function (value) { this._disabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "maximumValue", {
        /**
         * To be documented
         */
        set: function (value) { this._maximumValue = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "minimumValue", {
        /**
         * To be documented
         */
        set: function (value) { this._minimumValue = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "step", {
        /**
         * To be documented
         */
        set: function (value) { this._step = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "value", {
        /**
         * To be documented
         */
        set: function (value) { this._value = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "maximumTrackImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._maximumTrackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "maximumTrackTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._maximumTrackTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "minimumTrackImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._minimumTrackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "minimumTrackTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._minimumTrackTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "thumbImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._thumbImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slider.prototype, "trackImage", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._trackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Slider.prototype._handleValueChange = function (event) {
        //Event example: {value: 0.4325, target: 18}
        if (!wrapper_1.isAndroid() || event.fromUser) {
            this.valueChange.emit(event.value);
        }
    };
    Slider.prototype._handleSlidingComplete = function (event) {
        //Event example: {value: 0.4325, target: 18}
        this.slidingComplete.emit(event.value);
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Slider.prototype, "valueChange", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Slider.prototype, "slidingComplete", void 0);
    Slider = __decorate([
        core_1.Component({
            selector: 'Slider',
            inputs: ['disabled', 'maximumValue', 'minimumValue', 'step', 'value'].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-slider [disabled]=\"_disabled\"  [maximumValue]=\"_maximumValue\" [minimumValue]=\"_minimumValue\" [step]=\"_step\"  [value]=\"_value\"\n  onValueChange=\"true\" onSlidingComplete=\"true\" (topSlidingComplete)=\"_handleSlidingComplete($event)\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "></native-slider>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper])
    ], Slider);
    return Slider;
}(component_1.HighLevelComponent));
exports.Slider = Slider;
