import { EventEmitter } from "@angular/core";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./component";
/**
 * A component for displaying a switch.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Switch (change)="switched=$event"></Switch>`
})
export class Sample {
  switched: boolean = false;
 }
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class Switch extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    change: EventEmitter<boolean>;
    _on: boolean;
    _enabled: boolean;
    /**
     * To be documented
     */
    on: string;
    /**
     * To be documented
     */
    enabled: any;
    _onTintColor: number;
    _thumbTintColor: number;
    _tintColor: number;
    /**
     * To be documented
     * @platform ios
     */
    onTintColor: string;
    /**
     * To be documented
     * @platform ios
     */
    thumbTintColor: string;
    /**
     * To be documented
     * @platform ios
     */
    tintColor: string;
    _handleChange(event: any): void;
}
