"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var component_1 = require("./component");
var ANDROID_INPUTS = [];
var IOS_INPUTS = ['onTintColor', 'thumbTintColor', 'tintColor'];
var ANDROID_BINDINGS = "";
var IOS_BINDINGS = "[_onTintColor]=\"_onTintColor\" [thumbTintColor]=\"_thumbTintColor\" [tintColor]=\"_tintColor\" onChange=\"true\"";
/**
 * A component for displaying a switch.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Switch (change)="switched=$event"></Switch>`
})
export class Sample {
  switched: boolean = false;
 }
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var Switch = (function (_super) {
    __extends(Switch, _super);
    function Switch(wrapper) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.change = new core_1.EventEmitter();
        //Properties
        this._on = false;
        this._enabled = true;
        this.setDefaultStyle({ height: 31, width: 51 });
    }
    Object.defineProperty(Switch.prototype, "on", {
        /**
         * To be documented
         */
        set: function (value) { this._on = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "enabled", {
        /**
         * To be documented
         */
        set: function (value) { this._enabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "onTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._onTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "thumbTintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._thumbTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Switch.prototype, "tintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Switch.prototype._handleChange = function (event) {
        this._on = event.value;
        this.change.emit(this._on);
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], Switch.prototype, "change", void 0);
    Switch = __decorate([
        core_1.Component({
            selector: 'Switch',
            inputs: [
                'on', 'enabled'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-switch [_on]=\"_on\" [enabled]=\"_enabled\"\n  (topChange)=\"_handleChange($event)\" " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "></native-switch>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper])
    ], Switch);
    return Switch;
}(component_1.HighLevelComponent));
exports.Switch = Switch;
