import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./component";
/**
 * A component for displaying a text.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Text [style]="{margin: 10}">Horizontal</Text>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/text.html#style
 */
export declare class Text extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    _lineBreakMode: string;
    _numberOfLines: number;
    /**
     * To be documented
     */
    lineBreakMode: any;
    /**
     * To be documented
     */
    numberOfLines: any;
    _selectable: boolean;
    /**
     * To be documented
     * @platform android
     */
    selectable: any;
    _allowFontScaling: boolean;
    _suppressHighlighting: boolean;
    /**
     * To be documented
     * @platform ios
     */
    allowFontScaling: any;
    /**
     * To be documented
     * @platform ios
     */
    suppressHighlighting: any;
}
