"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var component_1 = require("./component");
var ANDROID_INPUTS = ['selectable'];
var IOS_INPUTS = ['allowFontScaling', 'suppressHighlighting'];
var ANDROID_BINDINGS = "[selectable]=\"_selectable\"";
var IOS_BINDINGS = "[allowFontScaling]=\"_allowFontScaling\" [suppressHighlighting]=\"_suppressHighlighting\"";
/**
 * A component for displaying a text.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Text [style]="{margin: 10}">Horizontal</Text>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/text.html#style
 */
var Text = (function (_super) {
    __extends(Text, _super);
    function Text(wrapper) {
        _super.call(this, wrapper);
    }
    Object.defineProperty(Text.prototype, "lineBreakMode", {
        /**
         * To be documented
         */
        set: function (value) { this._lineBreakMode = this.processEnum(value, ['tail', 'head', 'middle', 'clip']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "numberOfLines", {
        /**
         * To be documented
         */
        set: function (value) { this._numberOfLines = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "selectable", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._selectable = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "allowFontScaling", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._allowFontScaling = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Text.prototype, "suppressHighlighting", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._suppressHighlighting = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Text = __decorate([
        core_1.Component({
            selector: 'Text',
            inputs: [
                'lineBreakMode', 'numberOfLines'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-text [lineBreakMode]=\"_lineBreakMode\" [numberOfLines]=\"_numberOfLines\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "><ng-content></ng-content></native-text>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper])
    ], Text);
    return Text;
}(component_1.HighLevelComponent));
exports.Text = Text;
