import { ElementRef, EventEmitter, OnInit } from "@angular/core";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./component";
/**
 * A component for displaying a textinput.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<TextInput placeholder="Type in" (submit)="typed=$event"></TextInput>`
})
export class Sample {
  typed: string = "";
}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class TextInput extends HighLevelComponent implements OnInit {
    private _nativeElement;
    constructor(wrapper: ReactNativeWrapper, el: ElementRef);
    /**
     * To be documented
     */
    focus: EventEmitter<any>;
    /**
     * To be documented
     */
    change: EventEmitter<string>;
    /**
     * To be documented
     */
    keyPress: EventEmitter<string>;
    /**
     * To be documented
     */
    submit: EventEmitter<string>;
    /**
     * To be documented
     */
    blur: EventEmitter<any>;
    /**
     * To be documented
     */
    endEditing: EventEmitter<string>;
    /**
     * To be documented
     */
    contentSizeChange: EventEmitter<string>;
    defaultValue: string;
    _autoFocus: boolean;
    _value: string;
    _nativeValue: string;
    /**
     * To be documented
     */
    autoFocus: any;
    /**
     * To be documented
     */
    value: string;
    _autoCapitalize: string;
    _autoCorrect: boolean;
    _blurOnSubmit: boolean;
    _editable: boolean;
    _keyboardType: string;
    _maxLength: number;
    _multiline: boolean;
    _placeholder: string;
    _placeholderTextColor: number;
    _returnKeyType: string;
    _secureTextEntry: boolean;
    _selectionColor: number;
    _selectTextOnFocus: boolean;
    /**
     * To be documented
     */
    autoCapitalize: string;
    /**
     * To be documented
     */
    autoCorrect: any;
    /**
     * To be documented
     */
    blurOnSubmit: any;
    /**
     * To be documented
     */
    editable: any;
    /**
     * To be documented
     */
    keyboardType: string;
    /**
     * To be documented
     */
    maxLength: any;
    /**
     * To be documented
     */
    multiline: any;
    /**
     * To be documented
     */
    placeholder: string;
    /**
     * To be documented
     */
    placeholderTextColor: string;
    /**
     * To be documented
     * // Cross-platform
     * 'done', 'go', 'next', 'search', 'send',
     * // Android-only
     * 'none', 'previous',
     * // iOS-only
     * 'default', 'emergency-call', 'google', 'join', 'route', 'yahoo'
     */
    returnKeyType: string;
    /**
     * To be documented
     */
    secureTextEntry: any;
    /**
     * To be documented
     */
    selectionColor: string;
    /**
     * To be documented
     */
    selectTextOnFocus: any;
    _numberOfLines: number;
    _returnKeyLabel: string;
    _underlineColorAndroid: number;
    /**
     * To be documented
     * @platform android
     */
    numberOfLines: any;
    /**
     * To be documented
     * @platform android
     */
    returnKeyLabel: string;
    /**
     * To be documented
     * @platform android
     */
    underlineColorAndroid: string;
    _clearButtonMode: boolean;
    _clearTextOnFocus: boolean;
    _dataDetectorTypes: string;
    _enablesReturnKeyAutomatically: boolean;
    _keyboardAppearance: string;
    /**
     * To be documented
     * @platform ios
     */
    clearButtonMode: any;
    /**
     * To be documented
     * @platform ios
     */
    clearTextOnFocus: any;
    /**
     * To be documented
     * @platform ios
     */
    dataDetectorTypes: string;
    /**
     * To be documented
     * @platform ios
     */
    enablesReturnKeyAutomatically: any;
    /**
     * To be documented
     * @platform ios
     */
    keyboardAppearance: string;
    _handleFocus(): void;
    _handleChange(event: any): void;
    _handleKeyPress(event: any): void;
    _handleSubmitEditing(event: any): void;
    _handleBlur(): void;
    _handleEndEditing(event: any): void;
    _handleContentSizeChange(event: any): void;
    /**
     * To be documented
     */
    blurTextInput(): void;
    /**
     * To be documented
     */
    focusTextInput(): void;
    ngOnInit(): void;
    _getText(): string;
}
