"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var component_1 = require("./component");
var ANDROID_INPUTS = ['numberOfLines', 'returnKeyLabel', 'underlineColorAndroid'];
var IOS_INPUTS = ['clearButtonMode', 'clearTextOnFocus', 'dataDetectorTypes',
    'enablesReturnKeyAutomatically', 'keyboardAppearance'];
var ANDROID_BINDINGS = "[numberOfLines]=\"_numberOfLines\" [underlineColorAndroid]=\"_underlineColorAndroid\"\n  [returnKeyLabel]=\"_returnKeyLabel\" (topTextInput)=\"_handleKeyPress($event)\"\n  mostRecentEventCount=\"0\"";
var IOS_BINDINGS = "[clearButtonMode]=\"_clearButtonMode\" [clearTextOnFocus]=\"_clearTextOnFocus\"\n  [dataDetectorTypes]=\"_dataDetectorTypes\"\n  [enablesReturnKeyAutomatically]=\"_enablesReturnKeyAutomatically\" [keyboardAppearance]=\"_keyboardAppearance\"\n  (topKeyPress)=\"_handleKeyPress($event)\"";
/**
 * A component for displaying a textinput.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<TextInput placeholder="Type in" (submit)="typed=$event"></TextInput>`
})
export class Sample {
  typed: string = "";
}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var TextInput = (function (_super) {
    __extends(TextInput, _super);
    function TextInput(wrapper, el) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.focus = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.change = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.keyPress = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.submit = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.blur = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.endEditing = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.contentSizeChange = new core_1.EventEmitter();
        this._autoFocus = false;
        this._value = null;
        this._nativeValue = null;
        this._nativeElement = el.nativeElement;
        if (!wrapper.isAndroid()) {
            this.setDefaultStyle({ height: 40 });
        }
    }
    Object.defineProperty(TextInput.prototype, "autoFocus", {
        /**
         * To be documented
         */
        set: function (value) { this._autoFocus = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "value", {
        /**
         * To be documented
         */
        set: function (value) {
            this._value = value;
            this._nativeValue = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "autoCapitalize", {
        /**
         * To be documented
         */
        set: function (value) { this._autoCapitalize = this.processEnum(value, ['none', 'sentences', 'words', 'characters']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "autoCorrect", {
        /**
         * To be documented
         */
        set: function (value) { this._autoCorrect = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "blurOnSubmit", {
        /**
         * To be documented
         */
        set: function (value) { this._blurOnSubmit = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "editable", {
        /**
         * To be documented
         */
        set: function (value) { this._editable = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "keyboardType", {
        /**
         * To be documented
         */
        set: function (value) { this._autoCapitalize = this.processEnum(value, ['default', 'email-address', 'numeric', 'phone-pad', 'ascii-capable', 'numbers-and-punctuation', 'url', 'number-pad', 'name-phone-pad', 'decimal-pad', 'twitter', 'web-search']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "maxLength", {
        /**
         * To be documented
         */
        set: function (value) { this._maxLength = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "multiline", {
        /**
         * To be documented
         */
        set: function (value) { this._multiline = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "placeholder", {
        /**
         * To be documented
         */
        set: function (value) { this._placeholder = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "placeholderTextColor", {
        /**
         * To be documented
         */
        set: function (value) { this._placeholderTextColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "returnKeyType", {
        /**
         * To be documented
         * // Cross-platform
         * 'done', 'go', 'next', 'search', 'send',
         * // Android-only
         * 'none', 'previous',
         * // iOS-only
         * 'default', 'emergency-call', 'google', 'join', 'route', 'yahoo'
         */
        set: function (value) { this._returnKeyType = this.processEnum(value, ['done', 'go', 'next', 'search', 'send', 'none', 'previous', 'default', 'emergency-call', 'google', 'join', 'route', 'yahoo']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "secureTextEntry", {
        /**
         * To be documented
         */
        set: function (value) { this._secureTextEntry = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "selectionColor", {
        /**
         * To be documented
         */
        set: function (value) { this._selectionColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "selectTextOnFocus", {
        /**
         * To be documented
         */
        set: function (value) { this._selectTextOnFocus = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "numberOfLines", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._numberOfLines = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "returnKeyLabel", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._returnKeyLabel = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "underlineColorAndroid", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._underlineColorAndroid = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "clearButtonMode", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._clearButtonMode = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "clearTextOnFocus", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._clearTextOnFocus = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "dataDetectorTypes", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._dataDetectorTypes = this.processEnum(value, ['phoneNumber', 'link', 'address', 'calendarEvent', 'none', 'all']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "enablesReturnKeyAutomatically", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._enablesReturnKeyAutomatically = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "keyboardAppearance", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._keyboardAppearance = this.processEnum(value, ['default', 'light', 'dark']); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    TextInput.prototype._handleFocus = function () {
        this.focus.emit(null);
    };
    TextInput.prototype._handleChange = function (event) {
        this._nativeElement.children[0].setProperty('mostRecentEventCount', event.eventCount);
        this.change.emit(event.text);
        if (event.text != this._nativeValue) {
            this._nativeValue = event.text;
        }
    };
    TextInput.prototype._handleKeyPress = function (event) {
        this.keyPress.emit(event.text);
    };
    TextInput.prototype._handleSubmitEditing = function (event) {
        this.submit.emit(event.text);
    };
    TextInput.prototype._handleBlur = function () {
        this.blur.emit(null);
    };
    TextInput.prototype._handleEndEditing = function (event) {
        this.endEditing.emit(event.text);
    };
    TextInput.prototype._handleContentSizeChange = function (event) {
        this.contentSizeChange.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    TextInput.prototype.blurTextInput = function () {
        this._nativeElement.children[0].blur();
    };
    /**
     * To be documented
     */
    TextInput.prototype.focusTextInput = function () {
        this._nativeElement.children[0].focus();
    };
    //Lifecycle
    TextInput.prototype.ngOnInit = function () {
        var _this = this;
        if (this._autoFocus) {
            setTimeout(function () {
                _this.focusTextInput();
            }, 0);
        }
        this._nativeValue = this._getText();
    };
    TextInput.prototype._getText = function () {
        return (this._value && this._value.length > 0) ? this._value : this.defaultValue;
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "focus", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "change", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "keyPress", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "submit", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "blur", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "endEditing", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], TextInput.prototype, "contentSizeChange", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TextInput.prototype, "defaultValue", void 0);
    TextInput = __decorate([
        core_1.Component({
            selector: 'TextInput',
            inputs: [
                //Non-native
                'autoFocus', 'value',
                //Native
                'autoCapitalize', 'autoCorrect', 'blurOnSubmit', 'editable', 'keyboardType', 'maxLength', 'multiline',
                'placeholder', 'placeholderTextColor', 'returnKeyType', 'secureTextEntry', 'selectionColor', 'selectTextOnFocus'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-textinput [text]=\"_nativeValue\" [autoCapitalize]=\"_autoCapitalize\" [autoCorrect]=\"_autoCorrect\" [blurOnSubmit]=\"_blurOnSubmit\" [editable]=\"_editable\" [keyboardType]=\"_keyboardType\"\n  [maxLength]=\"_maxLength\" [multiline]=\"_multiline\" [placeholder]=\"_placeholder\" [placeholderTextColor]=\"_placeholderTextColor\" [secureTextEntry]=\"_secureTextEntry\"\n  [returnKeyType]=\"_returnKeyType\" [selectionColor]=\"_selectionColor\" [selectTextOnFocus]=\"_selectTextOnFocus\"\n  (tap)=\"focusTextInput()\" (topFocus)=\"_handleFocus()\" (topChange)=\"_handleChange($event)\" (topSubmitEditing)=\"_handleSubmitEditing($event)\"\n  (topBlur)=\"_handleBlur()\" (topEndEditing)=\"_handleEndEditing($event)\" (topContentSizeChange)=\"_handleContentSizeChange($event)\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "></native-textinput>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper, core_1.ElementRef])
    ], TextInput);
    return TextInput;
}(component_1.HighLevelComponent));
exports.TextInput = TextInput;
