"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var component_1 = require("./component");
/**
 * A component for displaying a view, the default container.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<View></View>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var View = (function (_super) {
    __extends(View, _super);
    function View(wrapper, el) {
        _super.call(this, wrapper);
        this._nativeElement = el.nativeElement;
    }
    //Commands
    /**
     * To be documented
     */
    View.prototype.setPressed = function (isPressed) {
        this._nativeElement.children[0].dispatchCommand('setPressed', [isPressed]);
    };
    /**
     * To be documented
     */
    View.prototype.hotspotUpdate = function (x, y) {
        this._nativeElement.children[0].dispatchCommand('hotspotUpdate', [x || 0, y || 0]);
    };
    View = __decorate([
        core_1.Component({
            selector: 'View',
            inputs: component_1.GENERIC_INPUTS,
            template: "<native-view " + component_1.GENERIC_BINDINGS + "><ng-content></ng-content></native-view>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper, core_1.ElementRef])
    ], View);
    return View;
}(component_1.HighLevelComponent));
exports.View = View;
