import { EventEmitter, ElementRef } from "@angular/core";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./component";
/**
 * A component for displaying a webview
 *
 * ```
@Component({
  selector: 'sample',
  template: `<WebView [source]="{uri: 'https://www.angular.io'}" javaScriptEnabled="true" domStorageEnabled="true">
    </WebView>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
export declare class WebView extends HighLevelComponent {
    private _nativeElement;
    constructor(wrapper: ReactNativeWrapper, el: ElementRef);
    /**
     * To be documented
     */
    loadingStart: EventEmitter<any>;
    /**
     * To be documented
     */
    loadingFinish: EventEmitter<any>;
    /**
     * To be documented
     */
    loadingError: EventEmitter<any>;
    /**
     * To be documented
     */
    contentSizeChange: EventEmitter<any>;
    _automaticallyAdjustContentInsets: boolean;
    _contentInset: any;
    _injectedJavaScript: string;
    _scalesPageToFit: boolean;
    _source: any;
    /**
     * To be documented
     */
    automaticallyAdjustContentInsets: any;
    /**
     * To be documented
     */
    contentInset: any;
    /**
     * To be documented
     */
    injectedJavaScript: any;
    /**
     * To be documented
     */
    scalesPageToFit: any;
    /**
     * To be documented
     */
    source: any;
    _domStorageEnabled: boolean;
    _javaScriptEnabled: boolean;
    /**
     * To be documented
     * @platform android
     */
    domStorageEnabled: any;
    /**
     * To be documented
     * @platform android
     */
    javaScriptEnabled: any;
    _allowsInlineMediaPlayback: boolean;
    _scrollEnabled: boolean;
    _decelerationRate: number;
    _bounces: boolean;
    /**
     * To be documented
     * @platform ios
     */
    allowsInlineMediaPlayback: any;
    /**
     * To be documented
     * @platform ios
     */
    bounces: any;
    /**
     * To be documented
     * @platform ios
     */
    decelerationRate: any;
    /**
     * To be documented
     * @platform ios
     */
    scrollEnabled: any;
    _handleLoadingStart(event: any): void;
    _handleLoadingFinish(event: any): void;
    _handleLoadingError(event: any): void;
    _handleContentSizeChange(event: any): void;
    /**
     * To be documented
     */
    goForward(): void;
    /**
     * To be documented
     */
    reload(): void;
    /**
     * To be documented
     */
    goBack(): void;
}
