"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var renderer_1 = require("../../renderer/renderer");
var wrapper_1 = require("../../wrapper/wrapper");
var component_1 = require("./component");
var ANDROID_INPUTS = ['domStorageEnabled', 'javaScriptEnabled'];
var IOS_INPUTS = ['allowsInlineMediaPlayback', 'bounces', 'decelerationRate', 'scrollEnabled'];
var ANDROID_BINDINGS = "[domStorageEnabled]=\"_domStorageEnabled\" [javaScriptEnabled]=\"_javaScriptEnabled\"";
var IOS_BINDINGS = "[allowsInlineMediaPlayback]=\"_allowsInlineMediaPlayback\" [bounces]=\"_bounces\" [decelerationRate]=\"_decelerationRate\"\n  [scrollEnabled]=\"_scrollEnabled\"";
//TODO: onNavigationStateChange, renderError, renderLoading, startInLoadingState, processDecelerationRate(iOS)
/**
 * A component for displaying a webview
 *
 * ```
@Component({
  selector: 'sample',
  template: `<WebView [source]="{uri: 'https://www.angular.io'}" javaScriptEnabled="true" domStorageEnabled="true">
    </WebView>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var WebView = (function (_super) {
    __extends(WebView, _super);
    function WebView(wrapper, el) {
        _super.call(this, wrapper);
        //Events
        /**
         * To be documented
         */
        this.loadingStart = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.loadingFinish = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.loadingError = new core_1.EventEmitter();
        /**
         * To be documented
         */
        this.contentSizeChange = new core_1.EventEmitter();
        this._nativeElement = el.nativeElement;
    }
    Object.defineProperty(WebView.prototype, "automaticallyAdjustContentInsets", {
        /**
         * To be documented
         */
        set: function (value) { this._automaticallyAdjustContentInsets = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "contentInset", {
        /**
         * To be documented
         */
        set: function (value) { this._contentInset = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "injectedJavaScript", {
        /**
         * To be documented
         */
        set: function (value) { this._injectedJavaScript = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "scalesPageToFit", {
        /**
         * To be documented
         */
        set: function (value) { this._scalesPageToFit = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "source", {
        /**
         * To be documented
         */
        set: function (value) { this._source = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "domStorageEnabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._domStorageEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "javaScriptEnabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._javaScriptEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "allowsInlineMediaPlayback", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._allowsInlineMediaPlayback = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "bounces", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._bounces = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "decelerationRate", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._decelerationRate = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "scrollEnabled", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    WebView.prototype._handleLoadingStart = function (event) {
        this.loadingStart.emit({ canGoBack: event.canGoBack, canGoForward: event.canGoForward, loading: event.loading, title: event.title, url: event.url });
    };
    WebView.prototype._handleLoadingFinish = function (event) {
        this.loadingFinish.emit({ canGoBack: event.canGoBack, canGoForward: event.canGoForward, loading: event.loading, title: event.title, url: event.url });
    };
    WebView.prototype._handleLoadingError = function (event) {
        this.loadingError.emit({ canGoBack: event.canGoBack, canGoForward: event.canGoForward, loading: event.loading, title: event.title, url: event.url, code: event.code, description: event.description });
    };
    WebView.prototype._handleContentSizeChange = function (event) {
        this.contentSizeChange.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    WebView.prototype.goForward = function () {
        this._nativeElement.children[0].dispatchCommand('goForward');
    };
    /**
     * To be documented
     */
    WebView.prototype.reload = function () {
        this._nativeElement.children[0].dispatchCommand('reload');
    };
    /**
     * To be documented
     */
    WebView.prototype.goBack = function () {
        this._nativeElement.children[0].dispatchCommand('goBack');
    };
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], WebView.prototype, "loadingStart", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], WebView.prototype, "loadingFinish", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], WebView.prototype, "loadingError", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', core_1.EventEmitter)
    ], WebView.prototype, "contentSizeChange", void 0);
    WebView = __decorate([
        core_1.Component({
            selector: 'WebView',
            inputs: [
                'automaticallyAdjustContentInsets', 'contentInset', 'injectedJavaScript', 'scalesPageToFit', 'source'
            ].concat(component_1.GENERIC_INPUTS).concat(wrapper_1.isAndroid() ? ANDROID_INPUTS : IOS_INPUTS),
            template: "<native-webview [automaticallyAdjustContentInsets]=\"_automaticallyAdjustContentInsets\" [contentInset]=\"_contentInset\"\n  [injectedJavaScript]=\"_injectedJavaScript\" [scalesPageToFit]=\"_scalesPageToFit\" [source]=\"_source\"\n  (topLoadingStart)=\"_handleLoadingStart($event)\" (topLoadingFinish)=\"_handleLoadingFinish($event)\" (topLoadingError)=\"_handleLoadingError($event)\"\n  (topContentSizeChange)=\"_handleContentSizeChange($event)\"\n  " + component_1.GENERIC_BINDINGS + " " + (wrapper_1.isAndroid() ? ANDROID_BINDINGS : IOS_BINDINGS) + "></native-webview>"
        }),
        __param(0, core_1.Inject(renderer_1.REACT_NATIVE_WRAPPER)), 
        __metadata('design:paramtypes', [wrapper_1.ReactNativeWrapper, core_1.ElementRef])
    ], WebView);
    return WebView;
}(component_1.HighLevelComponent));
exports.WebView = WebView;
