var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
var ANDROID_INPUTS = ['fadeDuration', 'loadingIndicatorSrc', 'progressiveRenderingEnabled', 'shouldNotifyLoadEvents'];
var IOS_INPUTS = ['blurRadius', 'capInsets', 'defaultSource'];
var ANDROID_BINDINGS = "[fadeDuration]=\"_fadeDuration\" [loadingIndicatorSrc]=\"_loadingIndicatorSrc ? _loadingIndicatorSrc.uri : null\"\n  [progressiveRenderingEnabled]=\"_progressiveRenderingEnabled\" [shouldNotifyLoadEvents]=\"_shouldNotifyLoadEvents\" [src]=\"_source ? [{uri: _source.uri}] : null\"";
var IOS_BINDINGS = "[blurRadius]=\"_blurRadius\" [capInsets]=\"_capInsets\" [defaultSource]=\"_defaultSource\" [source]=\"[_source]\"";
//TODO: add iOS specific events (onError, on Progress) and specific cases (tintColor, resizeMode)
/**
 * A component for displaying local or remote images.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<Image [source]="angularLogo"></Image>`
})
export class Sample {
  angularLogo: any = require('./assets/angular.png');
}
 * ```
 * @style https://facebook.github.io/react-native/docs/image.html#style
 */
var Image = (function (_super) {
    __extends(Image, _super);
    function Image(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.load = new EventEmitter();
        /**
         * To be documented
         */
        _this.loadStart = new EventEmitter();
        /**
         * To be documented
         */
        _this.loadEnd = new EventEmitter();
        return _this;
    }
    Object.defineProperty(Image.prototype, "resizeMode", {
        /**
         * To be documented
         */
        set: function (value) { this._resizeMode = this.processEnum(value, ['cover', 'contain', 'stretch', 'repeat', 'center']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "source", {
        /**
         * To be documented
         */
        set: function (value) { this._source = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "fadeDuration", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._fadeDuration = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "loadingIndicatorSrc", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._loadingIndicatorSrc = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "progressiveRenderingEnabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._progressiveRenderingEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "shouldNotifyLoadEvents", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._shouldNotifyLoadEvents = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "blurRadius", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._blurRadius = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "capInsets", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._capInsets = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Image.prototype, "defaultSource", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._defaultSource = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    Image.prototype._handleLoad = function () {
        this.load.emit(null);
    };
    Image.prototype._handleLoadStart = function () {
        this.loadStart.emit(null);
    };
    Image.prototype._handleLoadEnd = function (x, y) {
        this.loadEnd.emit(null);
    };
    return Image;
}(HighLevelComponent));
export { Image };
Image.decorators = [
    { type: Component, args: [{
                selector: 'Image',
                inputs: [
                    'resizeMode', 'source',
                    'accessibilityTraits', 'shouldRasterizeIOS',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style', 'blurRadius', 'capInsets', 'defaultSource'
                ],
                template: "<native-image  [resizeMode]=\"_resizeMode\"\n  (topLoad)=\"_handleLoad()\" (topLoadStart)=\"_handleLoadStart()\" (topLoadEnd)=\"_handleLoadEnd()\"\n  [accessibilityTraits]=\"_accessibilityTraits\" [shouldRasterizeIOS]=\"_shouldRasterizeIOS\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" [blurRadius]=\"_blurRadius\" [capInsets]=\"_capInsets\" [defaultSource]=\"_defaultSource\" [source]=\"[_source]\"><ng-content></ng-content></native-image>"
            },] },
];
/** @nocollapse */
Image.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
Image.propDecorators = {
    'load': [{ type: Output },],
    'loadStart': [{ type: Output },],
    'loadEnd': [{ type: Output },],
};
//# sourceMappingURL=_image.js.map