var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
var ANDROID_INPUTS = ['colors', 'enabled', 'progressBackgroundColor', 'progressViewOffset', 'size'];
var IOS_INPUTS = ['tintColor', 'title'];
var ANDROID_BINDINGS = "[colors]=\"_colors\" [enabled]=\"_enabled\" [progressBackgroundColor]=\"_progressBackgroundColor\"\n  [progressViewOffset]=\"_progressViewOffset\" [size]=\"_size\"";
var IOS_BINDINGS = "[tintColor]=\"_tintColor\" [title]=\"_title\" onRefresh=\"true\"";
/**
 * A component for displaying a refresh control.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<RefreshControl progressBackgroundColor="#ce0058" [colors]="['#00a9e0', '#309712']">
      <View></View>
    </RefreshControl>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var RefreshControl = (function (_super) {
    __extends(RefreshControl, _super);
    function RefreshControl(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.refresh = new EventEmitter();
        return _this;
    }
    Object.defineProperty(RefreshControl.prototype, "refreshing", {
        /**
         * To be documented
         */
        set: function (value) { this._refreshing = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "colors", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) {
            var _this = this;
            if (Array.isArray(value)) {
                this._colors = value.map(function (v) { return _this.processColor(v); });
            }
            else {
                this._colors = [this.processColor(value)];
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "enabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._enabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "progressBackgroundColor", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._progressBackgroundColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "progressViewOffset", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._progressViewOffset = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "size", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) {
            this._size = value === 'default' ?
                this.getUIManager().AndroidSwipeRefreshLayout.Constants.SIZE.DEFAULT :
                this.getUIManager().AndroidSwipeRefreshLayout.Constants.SIZE.LARGE;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "tintColor", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RefreshControl.prototype, "title", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._title = value; },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    RefreshControl.prototype._handleRefresh = function (event) {
        //Event example: null
        this.refresh.emit(null);
        event.target.setProperty('refreshing', !!this._refreshing);
    };
    return RefreshControl;
}(HighLevelComponent));
export { RefreshControl };
RefreshControl.decorators = [
    { type: Component, args: [{
                selector: 'RefreshControl',
                inputs: [
                    'refreshing',
                    'accessibilityTraits', 'shouldRasterizeIOS',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style', 'tintColor', 'title'
                ],
                template: "<native-refreshcontrol  [refreshing]=\"_refreshing\"\n  (topRefresh)=\"_handleRefresh($event)\"\n  [accessibilityTraits]=\"_accessibilityTraits\" [shouldRasterizeIOS]=\"_shouldRasterizeIOS\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" [tintColor]=\"_tintColor\" [title]=\"_title\" onRefresh=\"true\"><ng-content></ng-content></native-refreshcontrol>"
            },] },
];
/** @nocollapse */
RefreshControl.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
RefreshControl.propDecorators = {
    'refresh': [{ type: Output },],
};
//# sourceMappingURL=_refresh_control.js.map