var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Output, EventEmitter, Inject, ElementRef } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./_component";
var ANDROID_INPUTS = ['endFillColor'];
var IOS_INPUTS = ['alwaysBounceHorizontal', 'alwaysBounceVertical', 'automaticallyAdjustContentInsets', 'bounces', 'bouncesZoom',
    'canCancelContentTouches', 'centerContent', 'contentInset', 'contentOffset', 'decelerationRate', 'directionalLockEnabled',
    'indicatorStyle', 'maximumZoomScale', 'minimumZoomScale', 'scrollEventThrottle', 'scrollIndicatorInsets',
    'scrollsToTop', 'snapToAlignment', 'snapToInterval', 'stickyHeaderIndices', 'zoomScale'];
var ANDROID_BINDINGS = "[endFillColor]=\"_endFillColor\"";
var IOS_BINDINGS = "[alwaysBounceHorizontal]=\"_alwaysBounceHorizontal\" [alwaysBounceVertical]=\"_alwaysBounceVertical\"\n  [automaticallyAdjustContentInsets]=\"_automaticallyAdjustContentInsets\" [bounces]=\"_bounces\" [bouncesZoom]=\"_bouncesZoom\"\n  [canCancelContentTouches]=\"_canCancelContentTouches\" [centerContent]=\"_centerContent\" [contentInset]=\"_contentInset\"\n  [contentOffset]=\"_contentOffset\" [decelerationRate]=\"_decelerationRate\" [directionalLockEnabled]=\"_directionalLockEnabled\"\n  [indicatorStyle]=\"_indicatorStyle\" [maximumZoomScale]=\"_maximumZoomScale\" [minimumZoomScale]=\"_minimumZoomScale\"\n  [scrollEventThrottle]=\"_scrollEventThrottle\" [scrollIndicatorInsets]=\"_scrollIndicatorInsets\" [scrollsToTop]=\"_scrollsToTop\"\n  [snapToAlignment]=\"_snapToAlignment\" [snapToInterval]=\"_snapToInterval\" [stickyHeaderIndices]=\"_stickyHeaderIndices\" [zoomScale]=\"_zoomScale\"";
//TODO: refreshControl, onContentSizeChange, onScrollAnimationEnd
/**
 * A component for displaying a scrollview.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<ScrollView horizontal="true">
      <View></View>
      <View></View>
    </ScrollView>`
})
export class Sample {}
 * ```
 *
 * TODO: document usage of RefreshControl on Android and iOS
 *
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var ScrollView = (function (_super) {
    __extends(ScrollView, _super);
    function ScrollView(wrapper, el) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.scroll = new EventEmitter();
        /**
         * To be documented
         */
        _this.scrollBeginDrag = new EventEmitter();
        /**
         * To be documented
         */
        _this.scrollEndDrag = new EventEmitter();
        /**
         * To be documented
         */
        _this.momentumScrollBegin = new EventEmitter();
        /**
         * To be documented
         */
        _this.momentumScrollEnd = new EventEmitter();
        _this.setDefaultStyle({ overflow: 'scroll' });
        _this._nativeElement = el.nativeElement;
        return _this;
    }
    Object.defineProperty(ScrollView.prototype, "contentContainerStyle", {
        /**
         * To be documented
         */
        set: function (value) { this._contentContainerStyle = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "horizontal", {
        /**
         * To be documented
         */
        set: function (value) { this._horizontal = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "keyboardDismissMode", {
        /**
         * To be documented
         */
        set: function (value) { this._keyboardDismissMode = this.processEnum(value, ['none', 'on-drag', 'interactive']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "keyboardShouldPersistTaps", {
        /**
         * To be documented
         */
        set: function (value) { this._keyboardShouldPersistTaps = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "pagingEnabled", {
        /**
         * To be documented
         */
        set: function (value) { this._pagingEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollEnabled", {
        /**
         * To be documented
         */
        set: function (value) { this._scrollEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "sendMomentumEvents", {
        /**
         * To be documented
         */
        set: function (value) { this._sendMomentumEvents = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "showsHorizontalScrollIndicator", {
        /**
         * To be documented
         */
        set: function (value) { this._showsHorizontalScrollIndicator = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "showsVerticalScrollIndicator", {
        /**
         * To be documented
         */
        set: function (value) { this._showsVerticalScrollIndicator = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "endFillColor", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._endFillColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "alwaysBounceHorizontal", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._alwaysBounceHorizontal = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "alwaysBounceVertical", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._alwaysBounceVertical = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "automaticallyAdjustContentInsets", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._automaticallyAdjustContentInsets = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "bounces", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._bounces = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "bouncesZoom", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._bouncesZoom = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "canCancelContentTouches", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._canCancelContentTouches = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "centerContent", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._centerContent = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "contentInset", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._contentInset = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "contentOffset", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._contentOffset = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "decelerationRate", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) {
            if (value === 'normal') {
                this.getUIManager().RCTScrollView.Constants.DecelerationRate.normal;
            }
            else if (value === 'fast') {
                this.getUIManager().RCTScrollView.Constants.DecelerationRate.fast;
            }
            else {
                this._decelerationRate = this.processNumber(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "directionalLockEnabled", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._directionalLockEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "indicatorStyle", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._indicatorStyle = this.processEnum(value, ['default', 'black', 'white',]); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "maximumZoomScale", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._maximumZoomScale = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "minimumZoomScale", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._minimumZoomScale = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollEventThrottle", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollEventThrottle = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollIndicatorInsets", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollIndicatorInsets = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "scrollsToTop", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollsToTop = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "snapToAlignment", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._snapToAlignment = this.processEnum(value, ['start', 'center', 'end']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "snapToInterval", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._snapToInterval = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "stickyHeaderIndices", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._stickyHeaderIndices = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScrollView.prototype, "zoomScale", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._zoomScale = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    ScrollView.prototype._handleScroll = function (event) {
        // Event example:
        // {responderIgnoreScroll: true, layoutMeasurement: {height: 150, width: 400}, contentSize: {height: 150, width: 1200},
        // contentOffset: {x: 399.3, y: 0}, contentInset: {bottom: 0, left: 0, right: 0, top: 0}}
        this.scroll.emit(event);
    };
    ScrollView.prototype._handleScrollBeginDrag = function (event) {
        //Event example: see above
        this.scrollBeginDrag.emit(event);
    };
    ScrollView.prototype._handleScrollEndDrag = function (event) {
        //Event example: see above
        this.scrollEndDrag.emit(event);
    };
    ScrollView.prototype._handleMomentumScrollBegin = function (event) {
        //Event example: see above
        this.momentumScrollBegin.emit(event);
    };
    ScrollView.prototype._handleMomentumScrollEnd = function (event) {
        //Event example: see above
        this.momentumScrollEnd.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    ScrollView.prototype.scrollTo = function (x) {
        this._nativeElement.children[1].dispatchCommand('scrollTo', [x]);
    };
    /**
     * To be documented
     */
    ScrollView.prototype.scrollWithoutAnimationTo = function (x) {
        this._nativeElement.children[1].dispatchCommand('scrollWithoutAnimationTo', [x]);
    };
    return ScrollView;
}(HighLevelComponent));
export { ScrollView };
ScrollView.decorators = [
    { type: Component, args: [{
                selector: 'ScrollView',
                inputs: [
                    'contentContainerStyle', 'horizontal', 'keyboardDismissMode', 'keyboardShouldPersistTaps', 'pagingEnabled', 'scrollEnabled',
                    'sendMomentumEvents', 'showsHorizontalScrollIndicator', 'showsVerticalScrollIndicator',
                    'accessibilityTraits', 'shouldRasterizeIOS',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style', 'alwaysBounceHorizontal', 'alwaysBounceVertical', 'automaticallyAdjustContentInsets', 'bounces', 'bouncesZoom',
                    'canCancelContentTouches', 'centerContent', 'contentInset', 'contentOffset', 'decelerationRate', 'directionalLockEnabled',
                    'indicatorStyle', 'maximumZoomScale', 'minimumZoomScale', 'scrollEventThrottle', 'scrollIndicatorInsets',
                    'scrollsToTop', 'snapToAlignment', 'snapToInterval', 'stickyHeaderIndices', 'zoomScale'
                ],
                template: "\n  <native-scrollview [horizontal]=\"_horizontal\" [keyboardDismissMode]=\"_keyboardDismissMode\" [keyboardShouldPersistTaps]=\"_keyboardShouldPersistTaps\"\n  [pagingEnabled]=\"_pagingEnabled\" [scrollEnabled]=\"_scrollEnabled\" [sendMomentumEvents]=\"_sendMomentumEvents\"\n  [showsHorizontalScrollIndicator]=\"_showsHorizontalScrollIndicator\" [showsVerticalScrollIndicator]=\"_showsVerticalScrollIndicator\"\n  (topScroll)=\"_handleScroll($event)\" (topScrollBeginDrag)=\"_handleScrollBeginDrag($event)\" (topScrollEndDrag)=\"_handleScrollEndDrag($event)\"\n  (topMomentumScrollBegin)=\"_handleMomentumScrollBegin($event)\" (topMomentumScrollEnd)=\"_handleMomentumScrollEnd($event)\"\n  [flexDirection]=\"_horizontal ? 'row' : 'column'\"\n  [accessibilityTraits]=\"_accessibilityTraits\" [shouldRasterizeIOS]=\"_shouldRasterizeIOS\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" [alwaysBounceHorizontal]=\"_alwaysBounceHorizontal\" [alwaysBounceVertical]=\"_alwaysBounceVertical\"\n  [automaticallyAdjustContentInsets]=\"_automaticallyAdjustContentInsets\" [bounces]=\"_bounces\" [bouncesZoom]=\"_bouncesZoom\"\n  [canCancelContentTouches]=\"_canCancelContentTouches\" [centerContent]=\"_centerContent\" [contentInset]=\"_contentInset\"\n  [contentOffset]=\"_contentOffset\" [decelerationRate]=\"_decelerationRate\" [directionalLockEnabled]=\"_directionalLockEnabled\"\n  [indicatorStyle]=\"_indicatorStyle\" [maximumZoomScale]=\"_maximumZoomScale\" [minimumZoomScale]=\"_minimumZoomScale\"\n  [scrollEventThrottle]=\"_scrollEventThrottle\" [scrollIndicatorInsets]=\"_scrollIndicatorInsets\" [scrollsToTop]=\"_scrollsToTop\"\n  [snapToAlignment]=\"_snapToAlignment\" [snapToInterval]=\"_snapToInterval\" [stickyHeaderIndices]=\"_stickyHeaderIndices\" [zoomScale]=\"_zoomScale\">\n  <ng-content select=\"RefreshControl\"></ng-content>\n  <native-view [removeClippedSubviews]=\"_removeClippedSubviews\" [style]=\"_contentContainerStyle\" collapsable=\"false\"\n    [flexDirection]=\"_horizontal ? 'row' : null\">\n  <ng-content></ng-content></native-view>\n  </native-scrollview>"
            },] },
];
/** @nocollapse */
ScrollView.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
ScrollView.propDecorators = {
    'scroll': [{ type: Output },],
    'scrollBeginDrag': [{ type: Output },],
    'scrollEndDrag': [{ type: Output },],
    'momentumScrollBegin': [{ type: Output },],
    'momentumScrollEnd': [{ type: Output },],
};
//# sourceMappingURL=_scrollview.js.map