var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, ElementRef, Input, Output, EventEmitter } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./_component";
var ANDROID_INPUTS = ['numberOfLines', 'returnKeyLabel', 'underlineColorAndroid'];
var IOS_INPUTS = ['clearButtonMode', 'clearTextOnFocus', 'dataDetectorTypes',
    'enablesReturnKeyAutomatically', 'keyboardAppearance'];
var ANDROID_BINDINGS = "[numberOfLines]=\"_numberOfLines\" [underlineColorAndroid]=\"_underlineColorAndroid\"\n  [returnKeyLabel]=\"_returnKeyLabel\" (topTextInput)=\"_handleKeyPress($event)\"\n  mostRecentEventCount=\"0\"";
var IOS_BINDINGS = "[clearButtonMode]=\"_clearButtonMode\" [clearTextOnFocus]=\"_clearTextOnFocus\"\n  [dataDetectorTypes]=\"_dataDetectorTypes\"\n  [enablesReturnKeyAutomatically]=\"_enablesReturnKeyAutomatically\" [keyboardAppearance]=\"_keyboardAppearance\"\n  (topKeyPress)=\"_handleKeyPress($event)\"";
/**
 * A component for displaying a textinput.
 *
 * ```
@Component({
  selector: 'sample',
  template: `<TextInput placeholder="Type in" (submit)="typed=$event"></TextInput>`
})
export class Sample {
  typed: string = "";
}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var TextInput = (function (_super) {
    __extends(TextInput, _super);
    function TextInput(wrapper, el) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.focus = new EventEmitter();
        /**
         * To be documented
         */
        _this.change = new EventEmitter();
        /**
         * To be documented
         */
        _this.keyPress = new EventEmitter();
        /**
         * To be documented
         */
        _this.submit = new EventEmitter();
        /**
         * To be documented
         */
        _this.blur = new EventEmitter();
        /**
         * To be documented
         */
        _this.endEditing = new EventEmitter();
        /**
         * To be documented
         */
        _this.contentSizeChange = new EventEmitter();
        _this._autoFocus = false;
        _this._value = null;
        _this._nativeValue = null;
        _this._nativeElement = el.nativeElement;
        if (!wrapper.isAndroid()) {
            _this.setDefaultStyle({ height: 40 });
        }
        return _this;
    }
    Object.defineProperty(TextInput.prototype, "autoFocus", {
        /**
         * To be documented
         */
        set: function (value) { this._autoFocus = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "value", {
        /**
         * To be documented
         */
        set: function (value) {
            this._value = value;
            this._nativeValue = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "autoCapitalize", {
        /**
         * To be documented
         */
        set: function (value) { this._autoCapitalize = this.processEnum(value, ['none', 'sentences', 'words', 'characters']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "autoCorrect", {
        /**
         * To be documented
         */
        set: function (value) { this._autoCorrect = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "blurOnSubmit", {
        /**
         * To be documented
         */
        set: function (value) { this._blurOnSubmit = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "editable", {
        /**
         * To be documented
         */
        set: function (value) { this._editable = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "keyboardType", {
        /**
         * To be documented
         */
        set: function (value) { this._autoCapitalize = this.processEnum(value, ['default', 'email-address', 'numeric', 'phone-pad', 'ascii-capable', 'numbers-and-punctuation', 'url', 'number-pad', 'name-phone-pad', 'decimal-pad', 'twitter', 'web-search']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "maxLength", {
        /**
         * To be documented
         */
        set: function (value) { this._maxLength = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "multiline", {
        /**
         * To be documented
         */
        set: function (value) { this._multiline = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "placeholder", {
        /**
         * To be documented
         */
        set: function (value) { this._placeholder = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "placeholderTextColor", {
        /**
         * To be documented
         */
        set: function (value) { this._placeholderTextColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "returnKeyType", {
        /**
         * To be documented
         * // Cross-platform
         * 'done', 'go', 'next', 'search', 'send',
         * // Android-only
         * 'none', 'previous',
         * // iOS-only
         * 'default', 'emergency-call', 'google', 'join', 'route', 'yahoo'
         */
        set: function (value) { this._returnKeyType = this.processEnum(value, ['done', 'go', 'next', 'search', 'send', 'none', 'previous', 'default', 'emergency-call', 'google', 'join', 'route', 'yahoo']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "secureTextEntry", {
        /**
         * To be documented
         */
        set: function (value) { this._secureTextEntry = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "selectionColor", {
        /**
         * To be documented
         */
        set: function (value) { this._selectionColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "selectTextOnFocus", {
        /**
         * To be documented
         */
        set: function (value) { this._selectTextOnFocus = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "numberOfLines", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._numberOfLines = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "returnKeyLabel", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._returnKeyLabel = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "underlineColorAndroid", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._underlineColorAndroid = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "clearButtonMode", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._clearButtonMode = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "clearTextOnFocus", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._clearTextOnFocus = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "dataDetectorTypes", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._dataDetectorTypes = this.processEnum(value, ['phoneNumber', 'link', 'address', 'calendarEvent', 'none', 'all']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "enablesReturnKeyAutomatically", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._enablesReturnKeyAutomatically = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextInput.prototype, "keyboardAppearance", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._keyboardAppearance = this.processEnum(value, ['default', 'light', 'dark']); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    TextInput.prototype._handleFocus = function () {
        this.focus.emit(null);
    };
    TextInput.prototype._handleChange = function (event) {
        this._nativeElement.children[0].setProperty('mostRecentEventCount', event.eventCount);
        this.change.emit(event.text);
        if (event.text != this._nativeValue) {
            this._nativeValue = event.text;
        }
    };
    TextInput.prototype._handleKeyPress = function (event) {
        this.keyPress.emit(event.text);
    };
    TextInput.prototype._handleSubmitEditing = function (event) {
        this.submit.emit(event.text);
    };
    TextInput.prototype._handleBlur = function () {
        this.blur.emit(null);
    };
    TextInput.prototype._handleEndEditing = function (event) {
        this.endEditing.emit(event.text);
    };
    TextInput.prototype._handleContentSizeChange = function (event) {
        this.contentSizeChange.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    TextInput.prototype.blurTextInput = function () {
        this._nativeElement.children[0].blur();
    };
    /**
     * To be documented
     */
    TextInput.prototype.focusTextInput = function () {
        this._nativeElement.children[0].focus();
    };
    //Lifecycle
    TextInput.prototype.ngOnInit = function () {
        var _this = this;
        if (this._autoFocus) {
            setTimeout(function () {
                _this.focusTextInput();
            }, 0);
        }
        this._nativeValue = this._getText();
    };
    TextInput.prototype._getText = function () {
        return (this._value && this._value.length > 0) ? this._value : this.defaultValue;
    };
    return TextInput;
}(HighLevelComponent));
export { TextInput };
TextInput.decorators = [
    { type: Component, args: [{
                selector: 'TextInput',
                inputs: [
                    //Non-native
                    'autoFocus', 'value',
                    //Native
                    'autoCapitalize', 'autoCorrect', 'blurOnSubmit', 'editable', 'keyboardType', 'maxLength', 'multiline',
                    'placeholder', 'placeholderTextColor', 'returnKeyType', 'secureTextEntry', 'selectionColor', 'selectTextOnFocus',
                    'accessibilityTraits', 'shouldRasterizeIOS',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style', 'clearButtonMode', 'clearTextOnFocus', 'dataDetectorTypes',
                    'enablesReturnKeyAutomatically', 'keyboardAppearance'
                ],
                template: "<native-textinput [text]=\"_nativeValue\" [autoCapitalize]=\"_autoCapitalize\" [autoCorrect]=\"_autoCorrect\" [blurOnSubmit]=\"_blurOnSubmit\" [editable]=\"_editable\" [keyboardType]=\"_keyboardType\"\n  [maxLength]=\"_maxLength\" [multiline]=\"_multiline\" [placeholder]=\"_placeholder\" [placeholderTextColor]=\"_placeholderTextColor\" [secureTextEntry]=\"_secureTextEntry\"\n  [returnKeyType]=\"_returnKeyType\" [selectionColor]=\"_selectionColor\" [selectTextOnFocus]=\"_selectTextOnFocus\"\n  (tap)=\"focusTextInput()\" (topFocus)=\"_handleFocus()\" (topChange)=\"_handleChange($event)\" (topSubmitEditing)=\"_handleSubmitEditing($event)\"\n  (topBlur)=\"_handleBlur()\" (topEndEditing)=\"_handleEndEditing($event)\" (topContentSizeChange)=\"_handleContentSizeChange($event)\"\n  [accessibilityTraits]=\"_accessibilityTraits\" [shouldRasterizeIOS]=\"_shouldRasterizeIOS\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" [clearButtonMode]=\"_clearButtonMode\" [clearTextOnFocus]=\"_clearTextOnFocus\"\n  [dataDetectorTypes]=\"_dataDetectorTypes\"\n  [enablesReturnKeyAutomatically]=\"_enablesReturnKeyAutomatically\" [keyboardAppearance]=\"_keyboardAppearance\"\n  (topKeyPress)=\"_handleKeyPress($event)\"></native-textinput>"
            },] },
];
/** @nocollapse */
TextInput.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
TextInput.propDecorators = {
    'focus': [{ type: Output },],
    'change': [{ type: Output },],
    'keyPress': [{ type: Output },],
    'submit': [{ type: Output },],
    'blur': [{ type: Output },],
    'endEditing': [{ type: Output },],
    'contentSizeChange': [{ type: Output },],
    'defaultValue': [{ type: Input },],
};
//# sourceMappingURL=_textinput.js.map