var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Output, EventEmitter, Inject, ElementRef } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
import { HighLevelComponent } from "./_component";
var ANDROID_INPUTS = ['domStorageEnabled', 'javaScriptEnabled'];
var IOS_INPUTS = ['allowsInlineMediaPlayback', 'bounces', 'decelerationRate', 'scrollEnabled'];
var ANDROID_BINDINGS = "[domStorageEnabled]=\"_domStorageEnabled\" [javaScriptEnabled]=\"_javaScriptEnabled\"";
var IOS_BINDINGS = "[allowsInlineMediaPlayback]=\"_allowsInlineMediaPlayback\" [bounces]=\"_bounces\" [decelerationRate]=\"_decelerationRate\"\n  [scrollEnabled]=\"_scrollEnabled\"";
//TODO: onNavigationStateChange, renderError, renderLoading, startInLoadingState, processDecelerationRate(iOS)
/**
 * A component for displaying a webview
 *
 * ```
@Component({
  selector: 'sample',
  template: `<WebView [source]="{uri: 'https://www.angular.io'}" javaScriptEnabled="true" domStorageEnabled="true">
    </WebView>`
})
export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 */
var WebView = (function (_super) {
    __extends(WebView, _super);
    function WebView(wrapper, el) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.loadingStart = new EventEmitter();
        /**
         * To be documented
         */
        _this.loadingFinish = new EventEmitter();
        /**
         * To be documented
         */
        _this.loadingError = new EventEmitter();
        /**
         * To be documented
         */
        _this.contentSizeChange = new EventEmitter();
        _this._nativeElement = el.nativeElement;
        return _this;
    }
    Object.defineProperty(WebView.prototype, "automaticallyAdjustContentInsets", {
        /**
         * To be documented
         */
        set: function (value) { this._automaticallyAdjustContentInsets = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "contentInset", {
        /**
         * To be documented
         */
        set: function (value) { this._contentInset = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "injectedJavaScript", {
        /**
         * To be documented
         */
        set: function (value) { this._injectedJavaScript = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "scalesPageToFit", {
        /**
         * To be documented
         */
        set: function (value) { this._scalesPageToFit = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "source", {
        /**
         * To be documented
         */
        set: function (value) { this._source = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "domStorageEnabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._domStorageEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "javaScriptEnabled", {
        /**
         * To be documented
         * @platform android
         */
        set: function (value) { this._javaScriptEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "allowsInlineMediaPlayback", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._allowsInlineMediaPlayback = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "bounces", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._bounces = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "decelerationRate", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._decelerationRate = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WebView.prototype, "scrollEnabled", {
        /**
         * To be documented
         * @platform ios
         */
        set: function (value) { this._scrollEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    //Event handlers
    WebView.prototype._handleLoadingStart = function (event) {
        this.loadingStart.emit({ canGoBack: event.canGoBack, canGoForward: event.canGoForward, loading: event.loading, title: event.title, url: event.url });
    };
    WebView.prototype._handleLoadingFinish = function (event) {
        this.loadingFinish.emit({ canGoBack: event.canGoBack, canGoForward: event.canGoForward, loading: event.loading, title: event.title, url: event.url });
    };
    WebView.prototype._handleLoadingError = function (event) {
        this.loadingError.emit({ canGoBack: event.canGoBack, canGoForward: event.canGoForward, loading: event.loading, title: event.title, url: event.url, code: event.code, description: event.description });
    };
    WebView.prototype._handleContentSizeChange = function (event) {
        this.contentSizeChange.emit(event);
    };
    //Commands
    /**
     * To be documented
     */
    WebView.prototype.goForward = function () {
        this._nativeElement.children[0].dispatchCommand('goForward');
    };
    /**
     * To be documented
     */
    WebView.prototype.reload = function () {
        this._nativeElement.children[0].dispatchCommand('reload');
    };
    /**
     * To be documented
     */
    WebView.prototype.goBack = function () {
        this._nativeElement.children[0].dispatchCommand('goBack');
    };
    return WebView;
}(HighLevelComponent));
export { WebView };
WebView.decorators = [
    { type: Component, args: [{
                selector: 'WebView',
                inputs: [
                    'automaticallyAdjustContentInsets', 'contentInset', 'injectedJavaScript', 'scalesPageToFit', 'source',
                    'accessibilityTraits', 'shouldRasterizeIOS',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style', 'allowsInlineMediaPlayback', 'bounces', 'decelerationRate', 'scrollEnabled'
                ],
                template: "<native-webview [automaticallyAdjustContentInsets]=\"_automaticallyAdjustContentInsets\" [contentInset]=\"_contentInset\"\n  [injectedJavaScript]=\"_injectedJavaScript\" [scalesPageToFit]=\"_scalesPageToFit\" [source]=\"_source\"\n  (topLoadingStart)=\"_handleLoadingStart($event)\" (topLoadingFinish)=\"_handleLoadingFinish($event)\" (topLoadingError)=\"_handleLoadingError($event)\"\n  (topContentSizeChange)=\"_handleContentSizeChange($event)\"\n  [accessibilityTraits]=\"_accessibilityTraits\" [shouldRasterizeIOS]=\"_shouldRasterizeIOS\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\" [allowsInlineMediaPlayback]=\"_allowsInlineMediaPlayback\" [bounces]=\"_bounces\" [decelerationRate]=\"_decelerationRate\"\n  [scrollEnabled]=\"_scrollEnabled\"></native-webview>"
            },] },
];
/** @nocollapse */
WebView.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
WebView.propDecorators = {
    'loadingStart': [{ type: Output },],
    'loadingFinish': [{ type: Output },],
    'loadingError': [{ type: Output },],
    'contentSizeChange': [{ type: Output },],
};
//# sourceMappingURL=_webview.js.map