import { EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a date picker.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<DatePicker date="2016-03-18" (change)="selectedDate=$event"></DatePicker>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
export declare class DatePicker extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     */
    change: EventEmitter<Date>;
    _date: number;
    _maximumDate: number;
    _minimumDate: number;
    _minuteInterval: number;
    _mode: string;
    _timeZoneOffsetInMinutes: number;
    /**
     * To be documented
     */
    date: any;
    /**
     * To be documented
     */
    maximumDate: any;
    /**
     * To be documented
     */
    minimumDate: string;
    /**
     * To be documented
     */
    minuteInterval: any;
    /**
     * To be documented
     */
    mode: string;
    /**
     * To be documented
     */
    timeZoneOffsetInMinutes: any;
    _handleChange(event: any): void;
}
