var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a date picker.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<DatePicker date="2016-03-18" (change)="selectedDate=$event"></DatePicker>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
var DatePicker = (function (_super) {
    __extends(DatePicker, _super);
    function DatePicker(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.change = new EventEmitter();
        _this.setDefaultStyle({ height: 216, width: 320 });
        return _this;
    }
    Object.defineProperty(DatePicker.prototype, "date", {
        /**
         * To be documented
         */
        set: function (value) { this._date = this.processDate(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "maximumDate", {
        /**
         * To be documented
         */
        set: function (value) { this._maximumDate = this.processDate(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "minimumDate", {
        /**
         * To be documented
         */
        set: function (value) { this._minimumDate = this.processDate(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "minuteInterval", {
        /**
         * To be documented
         */
        set: function (value) { this._minuteInterval = this.processEnum(this.processNumber(value), [1, 2, 3, 4, 5, 6, 10, 12, 15, 20, 30]); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "mode", {
        /**
         * To be documented
         */
        set: function (value) { this._mode = this.processEnum(value, ['date', 'time', 'datetime']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DatePicker.prototype, "timeZoneOffsetInMinutes", {
        /**
         * To be documented
         */
        set: function (value) { this._timeZoneOffsetInMinutes = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    DatePicker.prototype._handleChange = function (event) {
        //Event example: {target: 22, timestamp: 1458432000000}
        this.change.emit(new Date(event.timestamp));
    };
    return DatePicker;
}(HighLevelComponent));
export { DatePicker };
DatePicker.decorators = [
    { type: Component, args: [{
                selector: 'DatePicker',
                inputs: [
                    'date', 'maximumDate', 'minimumDate', 'minuteInterval', 'mode', 'timeZoneOffsetInMinutes',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-datepicker [date]=\"_date\" [maximumDate]=\"_maximumDate\"\n  [minimumDate]=\"_minimumDate\" [minuteInterval]=\"_minuteInterval\" [mode]=\"_mode\"\n  [timeZoneOffsetInMinutes]=\"_timeZoneOffsetInMinutes\" onChange=\"true\" (topChange)=\"_handleChange($event)\" [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"></native-datepicker>"
            },] },
];
/** @nocollapse */
DatePicker.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
DatePicker.propDecorators = {
    'change': [{ type: Output },],
};
//# sourceMappingURL=date_picker.js.map