var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Injector, Input, Output, EventEmitter, NgZone, ElementRef, ViewChild, ViewContainerRef, ComponentFactoryResolver } from "@angular/core";
import { LocationStrategy } from "@angular/common";
import { Router, ChildrenOutletContexts, PRIMARY_OUTLET } from "@angular/router";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
var NavigatorItem = (function (_super) {
    __extends(NavigatorItem, _super);
    function NavigatorItem(_componentFactoryResolver, _injector, wrapper) {
        var _this = _super.call(this, wrapper) || this;
        _this._componentFactoryResolver = _componentFactoryResolver;
        _this._injector = _injector;
        //Events
        _this.leftButtonPress = new EventEmitter();
        _this.rightButtonPress = new EventEmitter();
        _this.componentLoad = new EventEmitter();
        _this.setDefaultStyle({
            backgroundColor: 'white',
            overflow: 'hidden',
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 64,
        });
        return _this;
    }
    Object.defineProperty(NavigatorItem.prototype, "activatedRoute", {
        set: function (activatedRoute) {
            this._activatedRoute = activatedRoute;
            var data = activatedRoute.snapshot.data;
            if (data['title']) {
                this._title = data['title'];
            }
            if (data['titleImage']) {
                this._titleImage = this.resolveAssetSource(data['titleImage']);
            }
            if (data['backButtonTitle']) {
                this._backButtonTitle = data['backButtonTitle'];
            }
            if (data['leftButtonTitle']) {
                this._leftButtonTitle = data['leftButtonTitle'];
            }
            if (data['rightButtonTitle']) {
                this._rightButtonTitle = data['rightButtonTitle'];
            }
            if (data['navigationBarHidden']) {
                this.navigationBarHidden = this.processBoolean(data['navigationBarHidden']);
            }
            if (data['shadowHidden']) {
                this.shadowHidden = this.processBoolean(data['shadowHidden']);
            }
            if (data['translucent']) {
                this.translucent = this.processBoolean(data['translucent']);
            }
            if (data['barTintColor']) {
                this.barTintColor = this.processColor(data['barTintColor']);
            }
            if (data['tintColor']) {
                this.tintColor = this.processColor(data['tintColor']);
            }
            if (data['titleTextColor']) {
                this.titleTextColor = this.processColor(data['titleTextColor']);
            }
            if (data['backButtonIcon']) {
                this._backButtonIcon = this.resolveAssetSource(data['backButtonIcon']);
            }
            if (data['leftButtonIcon']) {
                this._leftButtonIcon = this.resolveAssetSource(data['leftButtonIcon']);
            }
            if (data['rightButtonIcon']) {
                this._rightButtonIcon = this.resolveAssetSource(data['rightButtonIcon']);
            }
            if (data['wrapperStyle']) {
                this._wrapperStyle = data['wrapperStyle'];
            }
        },
        enumerable: true,
        configurable: true
    });
    NavigatorItem.prototype._handleLeftButtonPress = function () {
        this.leftButtonPress.emit(this._activatedRoute);
    };
    NavigatorItem.prototype._handleRightButtonPress = function () {
        this.rightButtonPress.emit(this._activatedRoute);
    };
    NavigatorItem.prototype.ngAfterViewInit = function () {
        var component = this._activatedRoute.routeConfig.component;
        var componentFactory = this._componentFactoryResolver.resolveComponentFactory(component);
        var componentRef = this.target.createComponent(componentFactory, 0, this._injector, []);
        componentRef.changeDetectorRef.detectChanges();
        this.componentLoad.emit(componentRef.instance);
    };
    return NavigatorItem;
}(HighLevelComponent));
export { NavigatorItem };
NavigatorItem.decorators = [
    { type: Component, args: [{
                selector: 'NavigatorItem',
                inputs: ['activatedRoute'],
                template: "<native-navitem [title]=\"_title\" [titleImage]=\"_titleImage\" [backButtonTitle]=\"_backButtonTitle\" [leftButtonTitle]=\"_leftButtonTitle\" [rightButtonTitle]=\"_rightButtonTitle\"\n  [navigationBarHidden]=\"navigationBarHidden\" [shadowHidden]=\"shadowHidden\" [translucent]=\"translucent\"\n  [barTintColor]=\"barTintColor\" [tintColor]=\"tintColor\" [titleTextColor]=\"titleTextColor\"\n  [backButtonIcon]=\"_backButtonIcon\" [leftButtonIcon]=\"_leftButtonIcon\" [rightButtonIcon]=\"_rightButtonIcon\"\n  [style]=\"[_defaultStyle, itemWrapperStyle, _wrapperStyle]\" onLeftButtonPress=\"true\" onRightButtonPress=\"true\"\n  (topLeftButtonPress)=\"_handleLeftButtonPress()\" (topRightButtonPress)=\"_handleRightButtonPress()\">\n    <dummy-anchor-for-dynamic-loader #target></dummy-anchor-for-dynamic-loader>\n  </native-navitem>"
            },] },
];
/** @nocollapse */
NavigatorItem.ctorParameters = function () { return [
    { type: ComponentFactoryResolver, },
    { type: Injector, },
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
NavigatorItem.propDecorators = {
    'target': [{ type: ViewChild, args: ['target', { read: ViewContainerRef },] },],
    'itemWrapperStyle': [{ type: Input },],
    'navigationBarHidden': [{ type: Input },],
    'shadowHidden': [{ type: Input },],
    'translucent': [{ type: Input },],
    'barTintColor': [{ type: Input },],
    'tintColor': [{ type: Input },],
    'titleTextColor': [{ type: Input },],
    'leftButtonPress': [{ type: Output },],
    'rightButtonPress': [{ type: Output },],
    'componentLoad': [{ type: Output },],
};
/**
 * A component for displaying a navigator.
 *
 * It acts as the primary outlet for the router.
 * A Router's navigation triggers a navigation of the Navigator.
 *
 * For each route, additional data can be provided as follows:
 * {title: string, titleImage: any, backButtonIcon: any, backButtonTitle: string, leftButtonIcon: any, leftButtonTitle: string, rightButtonIcon: any, rightButtonTitle: string,
 * wrapperStyle: any, navigationBarHidden: boolean, shadowHidden: boolean, tintColor: string, barTintColor: string, titleTextColor: string, translucent: boolean}
 *
 * ```
@Component({
  selector: 'foo',
  template: `<View routerLink="bar"><Text>Foo from here</Text></View>`
})
class Foo {}

@Component({
  selector: 'bar',
  template: `<View><Text>Bar from here</Text></View>`
})
class Bar {}

@Component({
  selector: 'sample',
  template: `<Navigator (rightButtonPress)="_navigate($event)"></Navigator>`
})
export class Sample {
  constructor(private router: Router) {
  }

  _navigate(event: ActivatedRoute) {
    this.router.navigateByUrl('/bar');
  }
}


const moreLogo = require('../../assets/icon_more.png');
const appRoutes = [
 { path: '', component: Foo, data: {title: 'foo!', rightButtonIcon: moreLogo, backButtonTitle: 'back'}},
 { path: 'bar', component: Bar, data: {title: 'bar!'} }
];

@NgModule({
  declarations: [Sample, CompA, CompB],
  imports: [ReactNativeModule, CommonModule, ReactNativeRouterModule.forRoot(appRoutes)],
  bootstrap: [Sample]
})
export class AppModule {}

 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
var Navigator = (function (_super) {
    __extends(Navigator, _super);
    function Navigator(router, zone, locationStrategy, elementRef, parentContexts, wrapper) {
        var _this = _super.call(this, wrapper) || this;
        _this.router = router;
        _this.zone = zone;
        _this.locationStrategy = locationStrategy;
        _this.elementRef = elementRef;
        _this.parentContexts = parentContexts;
        _this._stack = [];
        _this._loadedComponents = [];
        //Events
        /**
         * To be documented
         */
        _this.leftButtonPress = new EventEmitter();
        /**
         * To be documented
         */
        _this.rightButtonPress = new EventEmitter();
        _this.__wrapper = wrapper;
        parentContexts.onChildOutletCreated(PRIMARY_OUTLET, _this);
        _this.setDefaultStyle({ flex: 1 });
        return _this;
    }
    Navigator.prototype.activateWith = function (activatedRoute, loadedResolver) {
        var _this = this;
        if (this._stack.length == 0) {
            this._stack.push(activatedRoute);
        }
        else {
            var navigator = this.elementRef.nativeElement.children[0];
            setTimeout(function () {
                _this.__wrapper.requestNavigatorLock(navigator.nativeTag, function (lockAcquired) { return _this._handleNavigation(lockAcquired, navigator, activatedRoute); });
            }, 0);
        }
    };
    Navigator.prototype.deactivate = function () { };
    Navigator.prototype.ngOnDestroy = function () { this.parentContexts.onChildOutletDestroyed(PRIMARY_OUTLET); };
    Navigator.prototype._handleNavigation = function (lockAcquired, navigator, activatedRoute) {
        var _this = this;
        this.zone.run(function () {
            if (lockAcquired) {
                if (_this._stack.map(function (ar) { return ar.routeConfig.path; }).indexOf(activatedRoute.routeConfig.path) == -1) {
                    _this._stack.push(activatedRoute);
                }
                else {
                    _this._stack.pop();
                }
                navigator.setProperty('requestedTopOfStack', _this._stack.length - 1, true);
            }
        });
    };
    Navigator.prototype._handleComponentLoad = function (cpt) {
        this._loadedComponents.push(cpt);
    };
    Object.defineProperty(Navigator.prototype, "activeComponent", {
        /**
         * To be documented
         */
        get: function () {
            return this._loadedComponents[this._loadedComponents.length - 1];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "barTintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._barTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "interactivePopGestureEnabled", {
        /**
         * To be documented
         */
        set: function (value) { this._interactivePopGestureEnabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "itemWrapperStyle", {
        /**
         * To be documented
         */
        set: function (value) { this._itemWrapperStyle = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "navigationBarHidden", {
        /**
         * To be documented
         */
        set: function (value) { this._navigationBarHidden = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "shadowHidden", {
        /**
         * To be documented
         */
        set: function (value) { this._shadowHidden = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "tintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "titleTextColor", {
        /**
         * To be documented
         */
        set: function (value) { this._titleTextColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Navigator.prototype, "translucent", {
        /**
         * To be documented
         */
        set: function (value) { this._translucent = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Navigator.prototype._handleLeftButtonPress = function (event) {
        this.leftButtonPress.emit(event);
    };
    Navigator.prototype._handleRightButtonPress = function (event) {
        this.rightButtonPress.emit(event);
    };
    Navigator.prototype._handleNavigationComplete = function (event) {
        if (this._stack.length > event.stackLength) {
            //Back button case
            this._loadedComponents.pop();
            this.locationStrategy.back();
        }
    };
    return Navigator;
}(HighLevelComponent));
export { Navigator };
Navigator.decorators = [
    { type: Component, args: [{
                selector: 'Navigator',
                inputs: [
                    'barTintColor', 'interactivePopGestureEnabled', 'itemWrapperStyle', 'navigationBarHidden', 'shadowHidden', 'tintColor', 'titleTextColor', 'translucent',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-navigator *ngIf=\"_stack.length > 0\" [interactivePopGestureEnabled]=\"_interactivePopGestureEnabled\" [requestedTopOfStack]=\"_requestedTopOfStack\"\n  onNavigationComplete=\"true\" (topNavigationComplete)=\"_handleNavigationComplete($event)\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\">\n    <NavigatorItem *ngFor=\"let activatedRoute of _stack\" [itemWrapperStyle]=\"_itemWrapperStyle\"\n    [barTintColor]=\"_barTintColor\" [navigationBarHidden]=\"_navigationBarHidden\"\n    [shadowHidden]=\"_shadowHidden\" [tintColor]=\"_tintColor\" [titleTextColor]=\"_titleTextColor\" [translucent]=\"_translucent\"\n    [activatedRoute]=\"activatedRoute\"\n    (leftButtonPress)=\"_handleLeftButtonPress($event)\" (rightButtonPress)=\"_handleRightButtonPress($event)\" (componentLoad)=\"_handleComponentLoad($event)\"></NavigatorItem>\n  </native-navigator>"
            },] },
];
/** @nocollapse */
Navigator.ctorParameters = function () { return [
    { type: Router, },
    { type: NgZone, },
    { type: LocationStrategy, },
    { type: ElementRef, },
    { type: ChildrenOutletContexts, },
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
Navigator.propDecorators = {
    'leftButtonPress': [{ type: Output },],
    'rightButtonPress': [{ type: Output },],
};
//# sourceMappingURL=navigator.js.map