var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying an progress view.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<ProgressView progress="0.6" progressTintColor="#ce0058"></ProgressView>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
var ProgressView = (function (_super) {
    __extends(ProgressView, _super);
    function ProgressView(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        _this.setDefaultStyle({ height: 2 });
        return _this;
    }
    Object.defineProperty(ProgressView.prototype, "progress", {
        /**
         * To be documented
         */
        set: function (value) { this._progress = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressView.prototype, "progressImage", {
        /**
         * To be documented
         */
        set: function (value) { this._progressImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressView.prototype, "progressTintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._progressTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressView.prototype, "progressViewStyle", {
        /**
         * To be documented
         */
        set: function (value) {
            this._progressViewStyle = this.processEnum(value, ['default', 'bar']);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressView.prototype, "trackImage", {
        /**
         * To be documented
         */
        set: function (value) { this._trackImage = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressView.prototype, "trackTintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._trackTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    return ProgressView;
}(HighLevelComponent));
export { ProgressView };
ProgressView.decorators = [
    { type: Component, args: [{
                selector: 'ProgressView',
                inputs: [
                    'progress', 'progressImage', 'progressTintColor', 'progressViewStyle', 'trackImage', 'trackTintColor',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-progressview [progress]=\"_progress\" [progressImage]=\"_progressImage\" [progressTintColor]=\"_progressTintColor\" [progressViewStyle]=\"_progressViewStyle\"\n  [trackImage]=\"_trackImage\" [trackTintColor]=\"_trackTintColor\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"></native-progressview>"
            },] },
];
/** @nocollapse */
ProgressView.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
//# sourceMappingURL=progress_view.js.map