import { EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a segmented control.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<SegmentedControl [values]="['One', 'Two','Three']" tintColor="#ce0058"></SegmentedControl>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
export declare class SegmentedControl extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    /**
     * To be documented
     * Emitted value example: {value: "One", selectedIndex: 0}
     */
    change: EventEmitter<any>;
    _enabled: boolean;
    _momentary: any;
    _selectedIndex: number;
    _tintColor: number;
    _values: Array<string>;
    /**
     * To be documented
     */
    enabled: string;
    /**
     * To be documented
     */
    momentary: any;
    /**
     * To be documented
     */
    selectedIndex: string;
    /**
     * To be documented
     */
    tintColor: string;
    /**
     * To be documented
     */
    values: Array<string>;
    _handleChange(event: any): void;
}
