var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a segmented control.
 *
 * ```
 @Component({
  selector: 'sample',
  template: `<SegmentedControl [values]="['One', 'Two','Three']" tintColor="#ce0058"></SegmentedControl>`
})
 export class Sample {}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
var SegmentedControl = (function (_super) {
    __extends(SegmentedControl, _super);
    function SegmentedControl(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         * Emitted value example: {value: "One", selectedIndex: 0}
         */
        _this.change = new EventEmitter();
        _this.setDefaultStyle({ height: 28 });
        return _this;
    }
    Object.defineProperty(SegmentedControl.prototype, "enabled", {
        /**
         * To be documented
         */
        set: function (value) { this._enabled = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SegmentedControl.prototype, "momentary", {
        /**
         * To be documented
         */
        set: function (value) { this._momentary = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SegmentedControl.prototype, "selectedIndex", {
        /**
         * To be documented
         */
        set: function (value) { this._selectedIndex = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SegmentedControl.prototype, "tintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SegmentedControl.prototype, "values", {
        /**
         * To be documented
         */
        set: function (value) { this._values = value; },
        enumerable: true,
        configurable: true
    });
    SegmentedControl.prototype._handleChange = function (event) {
        //Event example: {value: "One", selectedSegmentIndex: 0, target: 15}
        this.change.emit({ value: event.value, selectedIndex: event.selectedSegmentIndex });
    };
    return SegmentedControl;
}(HighLevelComponent));
export { SegmentedControl };
SegmentedControl.decorators = [
    { type: Component, args: [{
                selector: 'SegmentedControl',
                inputs: [
                    'enabled', 'momentary', 'selectedIndex', 'tintColor', 'values',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-segmentedcontrol [enabled]=\"_enabled\" [momentary]=\"_momentary\" [selectedIndex]=\"_selectedIndex\" [tintColor]=\"_tintColor\"\n  [values]=\"_values\" onChange=\"true\" (topChange)=\"_handleChange($event)\" [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"></native-segmentedcontrol>"
            },] },
];
/** @nocollapse */
SegmentedControl.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
SegmentedControl.propDecorators = {
    'change': [{ type: Output },],
};
//# sourceMappingURL=segmented_control.js.map