import { HighLevelComponent } from "./_component";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a tab bar.
 *
 * ```
@Component({
  selector: 'sample',
  template: `
<TabBar tintColor="white" barTintColor="darkslateblue">
  <TabBarItem systemIcon="history" [selected]="selectedTab == 'one'" (select)="selectedTab='one'"><Text>Tab one</Text></TabBarItem>
  <TabBarItem systemIcon="favorites" [selected]="selectedTab == 'two'" (select)="selectedTab='two'"><Text>Tab two</Text></TabBarItem>
  <TabBarItem systemIcon="featured" badge="8" [selected]="selectedTab == 'three'" (select)="selectedTab='three'"><Text>Tab three</Text></TabBarItem>
</TabBar>
  `
})
export class Sample {
  selectedTab: string = 'one';
}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
export declare class TabBar extends HighLevelComponent {
    constructor(wrapper: ReactNativeWrapper);
    _barTintColor: number;
    _itemPositioning: string;
    _tintColor: number;
    _translucent: boolean;
    /**
     * To be documented
     */
    barTintColor: string;
    /**
     * To be documented
     */
    itemPositioning: string;
    /**
     * To be documented
     */
    tintColor: string;
    /**
     * To be documented
     */
    translucent: string;
}
