var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying a tab bar.
 *
 * ```
@Component({
  selector: 'sample',
  template: `
<TabBar tintColor="white" barTintColor="darkslateblue">
  <TabBarItem systemIcon="history" [selected]="selectedTab == 'one'" (select)="selectedTab='one'"><Text>Tab one</Text></TabBarItem>
  <TabBarItem systemIcon="favorites" [selected]="selectedTab == 'two'" (select)="selectedTab='two'"><Text>Tab two</Text></TabBarItem>
  <TabBarItem systemIcon="featured" badge="8" [selected]="selectedTab == 'three'" (select)="selectedTab='three'"><Text>Tab three</Text></TabBarItem>
</TabBar>
  `
})
export class Sample {
  selectedTab: string = 'one';
}
 * ```
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
var TabBar = (function (_super) {
    __extends(TabBar, _super);
    function TabBar(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        _this.setDefaultStyle({ flex: 1 });
        return _this;
    }
    Object.defineProperty(TabBar.prototype, "barTintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._barTintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBar.prototype, "itemPositioning", {
        /**
         * To be documented
         */
        set: function (value) { this._itemPositioning = this.processEnum(value, ['auto', 'fill', 'center']); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBar.prototype, "tintColor", {
        /**
         * To be documented
         */
        set: function (value) { this._tintColor = this.processColor(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBar.prototype, "translucent", {
        /**
         * To be documented
         */
        set: function (value) { this._translucent = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    return TabBar;
}(HighLevelComponent));
export { TabBar };
TabBar.decorators = [
    { type: Component, args: [{
                selector: 'TabBar',
                inputs: [
                    'barTintColor', 'itemPositioning', 'tintColor', 'translucent',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-tabbar [barTintColor]=\"_barTintColor\" [itemPositioning]=\"_itemPositioning\" [tintColor]=\"_tintColor\" [translucent]=\"_translucent\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"><ng-content></ng-content></native-tabbar>"
            },] },
];
/** @nocollapse */
TabBar.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
//# sourceMappingURL=tabbar.js.map