var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from "@angular/core";
import { HighLevelComponent } from "./_component";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "../../wrapper/wrapper";
/**
 * A component for displaying an item of a tab bar.
 *
 * @style https://facebook.github.io/react-native/docs/view.html#style
 * @platform ios
 */
var TabBarItem = (function (_super) {
    __extends(TabBarItem, _super);
    function TabBarItem(wrapper) {
        var _this = _super.call(this, wrapper) || this;
        //Events
        /**
         * To be documented
         */
        _this.select = new EventEmitter();
        _this.setDefaultStyle({
            position: 'absolute',
            top: 0,
            right: 0,
            bottom: 0,
            left: 0,
        });
        return _this;
    }
    Object.defineProperty(TabBarItem.prototype, "badge", {
        /**
         * To be documented
         */
        set: function (value) { this._badge = this.processNumber(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBarItem.prototype, "icon", {
        /**
         * To be documented
         */
        set: function (value) { this._icon = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBarItem.prototype, "selected", {
        /**
         * To be documented
         */
        set: function (value) { this._selected = this.processBoolean(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBarItem.prototype, "selectedIcon", {
        /**
         * To be documented
         */
        set: function (value) { this._selectedIcon = this.resolveAssetSource(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBarItem.prototype, "systemIcon", {
        /**
         * To be documented
         */
        set: function (value) {
            this._systemIcon = this.processEnum(value, ['bookmarks', 'contacts', 'downloads', 'favorites', 'featured', 'history', 'more', 'most-recent', 'most-viewed', 'recents', 'search', 'top-rated']);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TabBarItem.prototype, "title", {
        /**
         * To be documented
         */
        set: function (value) { this._title = value; },
        enumerable: true,
        configurable: true
    });
    TabBarItem.prototype._handlePress = function () {
        this.select.emit(null);
    };
    return TabBarItem;
}(HighLevelComponent));
export { TabBarItem };
TabBarItem.decorators = [
    { type: Component, args: [{
                selector: 'TabBarItem',
                inputs: [
                    'badge', 'icon', 'selected', 'selectedIcon', 'systemIcon', 'title',
                    'collapsable', 'accessibilityLiveRegion', 'accessibilityComponentType',
                    'importantForAccessibility', 'needsOffscreenAlphaCompositing', 'renderToHardwareTextureAndroid ', 'nativeBackgroundAndroid',
                    //Both platforms
                    'accessible', 'accessibilityLabel', 'testID', 'pointerEvents', 'removeClippedSubviews', 'onLayout',
                    //Style
                    'styleSheet', 'style'
                ],
                template: "<native-tabbaritem [badge]=\"_badge\" [icon]=\"_icon\" [selected]=\"_selected\" [selectedIcon]=\"_selectedIcon\"\n  [systemIcon]=\"_systemIcon\" [title]=\"_title\" onPress=\"true\" (topPress)=\"_handlePress()\"\n  [collapsable]=\"_collapsable\" [accessibilityLiveRegion]=\"_accessibilityLiveRegion\"\n  [accessibilityComponentType]=\"_accessibilityComponentType\" [importantForAccessibility]=\"_importantForAccessibility\"\n  [needsOffscreenAlphaCompositing]=\"_needsOffscreenAlphaCompositing\" [renderToHardwareTextureAndroid]=\"_renderToHardwareTextureAndroid\"\n  [nativeBackgroundAndroid]=\"_nativeBackgroundAndroid\" [accessible]=\"_accessible\" [accessibilityLabel]=\"_accessibilityLabel\" [testID]=\"_testID\"\n  [pointerEvents]=\"_pointerEvents\" [removeClippedSubviews]=\"_removeClippedSubviews\" [_onLayout]=\"_onLayout\" [styleSheet]=\"_styleSheet\"\n  [style]=\"_style\"><ng-content *ngIf=\"_selected\"></ng-content></native-tabbaritem>"
            },] },
];
/** @nocollapse */
TabBarItem.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
]; };
TabBarItem.propDecorators = {
    'select': [{ type: Output },],
};
//# sourceMappingURL=tabbar_item.js.map