var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Directive, ElementRef, Input, Inject } from "@angular/core";
import { REACT_NATIVE_WRAPPER } from "./../../renderer/renderer";
import { ReactNativeWrapper } from "./../../wrapper/wrapper";
import { OpacityFeedback } from "../opacity_feedback";
var RippleFeedback = (function (_super) {
    __extends(RippleFeedback, _super);
    function RippleFeedback(wrapper, el) {
        var _this = _super.call(this, el) || this;
        _this._wrapper = wrapper;
        return _this;
    }
    RippleFeedback.prototype._start = function (event) {
        this._el.children[0].dispatchCommand('hotspotUpdate', [event.srcEvent.clientX || 0, event.srcEvent.clientY || 0]);
        this._el.children[0].dispatchCommand('setPressed', [true]);
    };
    RippleFeedback.prototype._stop = function (event) {
        this._el.children[0].dispatchCommand('hotspotUpdate', [event.srcEvent.clientX || 0, event.srcEvent.clientY || 0]);
        this._el.children[0].dispatchCommand('setPressed', [false]);
    };
    RippleFeedback.prototype.ngOnInit = function () {
        var _this = this;
        if (this._wrapper.isAndroid()) {
            this._el.children[0].addEventListener('tapstart', this._start.bind(this));
            this._el.children[0].addEventListener('tapcancel', this._stop.bind(this));
            this._el.children[0].addEventListener('tap', this._stop.bind(this));
            setTimeout(function () {
                _this._el.children[0].setProperty('nativeBackgroundAndroid', { type: 'RippleAndroid', color: _this._wrapper.processColor(_this.rippleFeedback) || -1, borderless: false });
            }, 0);
        }
        else {
            _super.prototype.ngOnInit.call(this);
        }
    };
    RippleFeedback.prototype.ngOnDestroy = function () {
        if (this._wrapper.isAndroid()) {
            this._el.children[0].removeEventListener('tapstart', this._start.bind(this));
            this._el.children[0].removeEventListener('tapcancel', this._stop.bind(this));
            this._el.children[0].removeEventListener('tap', this._stop.bind(this));
        }
        else {
            _super.prototype.ngOnDestroy.call(this);
        }
    };
    return RippleFeedback;
}(OpacityFeedback));
export { RippleFeedback };
RippleFeedback.decorators = [
    { type: Directive, args: [{
                selector: '[rippleFeedback]'
            },] },
];
/** @nocollapse */
RippleFeedback.ctorParameters = function () { return [
    { type: ReactNativeWrapper, decorators: [{ type: Inject, args: [REACT_NATIVE_WRAPPER,] },] },
    { type: ElementRef, },
]; };
RippleFeedback.propDecorators = {
    'rippleFeedback': [{ type: Input },],
};
//# sourceMappingURL=ripple_feedback.js.map