import { Directive, ElementRef } from "@angular/core";
var OpacityFeedback = (function () {
    function OpacityFeedback(el) {
        this._el = el.nativeElement;
    }
    OpacityFeedback.prototype._highlight = function () {
        this._el.children[0].setProperty('opacity', 0.5);
    };
    OpacityFeedback.prototype._unhighlight = function () {
        this._el.children[0].setProperty('opacity', 1);
    };
    OpacityFeedback.prototype.ngOnInit = function () {
        this._el.children[0].addEventListener('tapstart', this._highlight.bind(this));
        this._el.children[0].addEventListener('tapcancel', this._unhighlight.bind(this));
        this._el.children[0].addEventListener('tap', this._unhighlight.bind(this));
    };
    OpacityFeedback.prototype.ngOnDestroy = function () {
        this._el.children[0].removeEventListener('tapstart', this._highlight.bind(this));
        this._el.children[0].removeEventListener('tapcancel', this._unhighlight.bind(this));
        this._el.children[0].removeEventListener('tap', this._unhighlight.bind(this));
    };
    return OpacityFeedback;
}());
export { OpacityFeedback };
OpacityFeedback.decorators = [
    { type: Directive, args: [{
                selector: '[opacityFeedback]'
            },] },
];
/** @nocollapse */
OpacityFeedback.ctorParameters = function () { return [
    { type: ElementRef, },
]; };
//# sourceMappingURL=opacity_feedback.js.map