import { Node } from "./node";
import { ReactNativeWrapper } from "./../wrapper/wrapper";
export declare abstract class NativeCommand {
    target: Node;
    constructor(target: Node);
    execute(wrapper: ReactNativeWrapper): void;
    manageStyleProp(wrapper: ReactNativeWrapper, props: {
        [s: string]: any;
    }): {
        [s: string]: any;
    };
    _toArray(obj: any): any[];
    static mergers: Map<Node, any>;
    static addToMergers(node: Node, moveTag: number, addTag: number, removeTag: number): void;
    static mergeAndApply(wrapper: ReactNativeWrapper): void;
}
export declare class NativeCommandCreate extends NativeCommand {
    target: Node;
    props: {
        [s: string]: any;
    };
    constructor(target: Node);
    execute(wrapper: ReactNativeWrapper): void;
}
export declare class NativeCommandUpdate extends NativeCommand {
    target: Node;
    key: string;
    value: any;
    props: {
        [s: string]: any;
    };
    constructor(target: Node, key: string, value: any);
    execute(wrapper: ReactNativeWrapper): void;
}
export declare class NativeCommandAttach extends NativeCommand {
    target: Node;
    toRoot: boolean;
    constructor(target: Node, toRoot: boolean);
    execute(wrapper: ReactNativeWrapper): void;
}
export declare class NativeCommandAttachAfter extends NativeCommand {
    target: Node;
    anchor: Node;
    constructor(target: Node, anchor: Node);
    executeWithCounters(wrapper: ReactNativeWrapper, counters: Map<Node, number>): void;
    private _attach(wrapper, node, ancestor, counters, baseNativeIndex);
}
export declare class NativeCommandDetach extends NativeCommand {
    target: Node;
    constructor(target: Node);
    execute(wrapper: ReactNativeWrapper): void;
}
