import { ReactNativeWrapper } from "./../wrapper/wrapper";
export declare var nodeMap: Map<number, Node>;
export declare abstract class Node {
    rnWrapper: ReactNativeWrapper;
    zoneHolder: any;
    parent: Node;
    children: Node[];
    tagName: string;
    properties: {
        [s: string]: any;
    };
    isVirtual: boolean;
    toBeDestroyed: boolean;
    toBeMoved: boolean;
    isDestroyed: boolean;
    nativeTag: number;
    isCreated: boolean;
    nativeChildren: Array<number>;
    eventListeners: Map<string, Array<Function>>;
    _hammer: any;
    constructor(rnWrapper: ReactNativeWrapper, zoneHolder: any);
    attachTo(parent: Node): void;
    attachToAt(parent: Node, index: number): void;
    getInsertionNativeIndex(): number;
    getAncestorWithNativeCreated(): Node;
    getAncestorDestroyed(): Node;
    getFirstCreatedChild(): Node;
    isTextContainer(): boolean;
    isImageContainer(): boolean;
    overrideTagName(ancestor: Node): string;
    destroyNative(): void;
    setProperty(name: string, value: any, updateNative?: boolean): void;
    setProperties(properties: {
        [s: string]: any;
    }): void;
    addEventListener(eventName: string, handler: Function): void;
    removeEventListener(eventName: string, handler: Function): void;
    fireEvent(name: string, event: any): void;
    focus(): void;
    blur(): void;
    dispatchCommand(command: string, params?: any): void;
    getElementByTestId(testId: string): Node;
    querySelectorAll(selector: string): Array<Node>;
    querySelector(selector: string): Node;
    private _elementMatches(node, selector, matcher?);
}
export declare class ElementNode extends Node {
    tagName: string;
    constructor(tagName: string, wrapper: ReactNativeWrapper, zoneHolder: any);
}
export declare class TextNode extends Node {
    constructor(value: string, wrapper: ReactNativeWrapper, zoneHolder: any);
    setText(text: string): string;
}
export declare class CommentNode extends Node {
    constructor(wrapper: ReactNativeWrapper, zoneHolder: any);
}
