var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable, EventEmitter, NgZone } from "@angular/core";
import { LocationStrategy } from "@angular/common";
var ReactNativeLocationStrategy = (function (_super) {
    __extends(ReactNativeLocationStrategy, _super);
    function ReactNativeLocationStrategy(zone) {
        var _this = _super.call(this) || this;
        _this.zone = zone;
        _this.internalBaseHref = '/';
        _this.internalPath = '/';
        _this.internalTitle = '';
        _this.urlChanges = [];
        /** @internal */
        _this._subject = new EventEmitter();
        return _this;
    }
    ReactNativeLocationStrategy.prototype.simulatePopState = function (url) {
        this.internalPath = url;
        this._subject.emit(new _MockPopStateEvent(this.path()));
    };
    ReactNativeLocationStrategy.prototype.path = function () { return this.internalPath; };
    ReactNativeLocationStrategy.prototype.prepareExternalUrl = function (internal) {
        if (internal.startsWith('/') && this.internalBaseHref.endsWith('/')) {
            return this.internalBaseHref + internal.substring(1);
        }
        return this.internalBaseHref + internal;
    };
    ReactNativeLocationStrategy.prototype.pushState = function (ctx, title, path, query) {
        this.internalTitle = title;
        var url = path + (query.length > 0 ? ('?' + query) : '');
        this.internalPath = url;
        var externalUrl = this.prepareExternalUrl(url);
        this.urlChanges.push(externalUrl);
    };
    ReactNativeLocationStrategy.prototype.replaceState = function (ctx, title, path, query) {
        this.internalTitle = title;
        var url = path + (query.length > 0 ? ('?' + query) : '');
        this.internalPath = url;
        var externalUrl = this.prepareExternalUrl(url);
        this.urlChanges.push('replace: ' + externalUrl);
    };
    ReactNativeLocationStrategy.prototype.onPopState = function (fn) { this._subject.subscribe(fn); };
    ReactNativeLocationStrategy.prototype.getBaseHref = function () { return this.internalBaseHref; };
    ReactNativeLocationStrategy.prototype.back = function () {
        var _this = this;
        if (this.urlChanges.length > 0) {
            this.urlChanges.pop();
            var nextUrl = this.urlChanges.length > 0 ? this.urlChanges[this.urlChanges.length - 1] : '';
            this.zone.run(function () { return _this.simulatePopState(nextUrl.replace('replace: ', '')); });
        }
    };
    ReactNativeLocationStrategy.prototype.forward = function () { throw 'not implemented'; };
    ReactNativeLocationStrategy.prototype.canGoBack = function () {
        return this.urlChanges.length > 1;
    };
    return ReactNativeLocationStrategy;
}(LocationStrategy));
export { ReactNativeLocationStrategy };
ReactNativeLocationStrategy.decorators = [
    { type: Injectable },
];
/** @nocollapse */
ReactNativeLocationStrategy.ctorParameters = function () { return [
    { type: NgZone, },
]; };
var _MockPopStateEvent = (function () {
    function _MockPopStateEvent(newUrl) {
        this.newUrl = newUrl;
        this.pop = true;
        this.type = 'popstate';
    }
    return _MockPopStateEvent;
}());
//# sourceMappingURL=location_strategy.js.map