import { Directive, ElementRef, Input } from "@angular/core";
import { Router, ActivatedRoute } from '@angular/router';
var RouterLink = (function () {
    function RouterLink(router, route, el) {
        this.router = router;
        this.route = route;
        this.commands = [];
        this.event = 'tap';
        this._el = el.nativeElement;
    }
    Object.defineProperty(RouterLink.prototype, "routerLink", {
        set: function (data) {
            if (Array.isArray(data)) {
                this.commands = data;
            }
            else {
                this.commands = [data];
            }
        },
        enumerable: true,
        configurable: true
    });
    RouterLink.prototype.onEvent = function () {
        this.router.navigateByUrl(this.urlTree);
        return false;
    };
    Object.defineProperty(RouterLink.prototype, "urlTree", {
        get: function () {
            return this.router.createUrlTree(this.commands, {
                relativeTo: this.route,
                queryParams: this.queryParams,
                fragment: this.fragment,
                preserveQueryParams: toBool(this.preserveQueryParams),
                preserveFragment: toBool(this.preserveFragment)
            });
        },
        enumerable: true,
        configurable: true
    });
    RouterLink.prototype.ngOnInit = function () {
        this._el.addEventListener(this.event, this.onEvent.bind(this));
    };
    RouterLink.prototype.ngOnDestroy = function () {
        this._el.removeEventListener(this.event, this.onEvent.bind(this));
    };
    return RouterLink;
}());
export { RouterLink };
RouterLink.decorators = [
    { type: Directive, args: [{ selector: '[routerLink]' },] },
];
/** @nocollapse */
RouterLink.ctorParameters = function () { return [
    { type: Router, },
    { type: ActivatedRoute, },
    { type: ElementRef, },
]; };
RouterLink.propDecorators = {
    'queryParams': [{ type: Input },],
    'fragment': [{ type: Input },],
    'preserveQueryParams': [{ type: Input },],
    'preserveFragment': [{ type: Input },],
    'event': [{ type: Input },],
    'routerLink': [{ type: Input },],
};
function toBool(s) {
    if (s === '')
        return true;
    return !!s;
}
//# sourceMappingURL=router_link.js.map