"use strict";
var mock_application_ref_1 = require("./mock_application_ref");
var core_1 = require("@angular/core");
var testing_1 = require("@angular/core/testing");
var common_1 = require("@angular/common");
var compiler_1 = require("@angular/compiler");
var renderer_1 = require("../renderer/renderer");
var location_strategy_1 = require("../router/location_strategy");
var android_module_1 = require("../modules/android_module");
var date_picker_1 = require("./../components/ios/date_picker");
var navigator_1 = require("./../components/ios/navigator");
var progress_view_1 = require("./../components/ios/progress_view");
var segmented_control_1 = require("./../components/ios/segmented_control");
var tabbar_1 = require("./../components/ios/tabbar");
var tabbar_item_1 = require("./../components/ios/tabbar_item");
function configureTestingModule(mock, testCpt, declarations, modules) {
    if (declarations === void 0) { declarations = []; }
    if (modules === void 0) { modules = []; }
    var tb = testing_1.TestBed.configureTestingModule({
        imports: [android_module_1.ReactNativeAndroidModule].concat(modules),
        providers: getTestingProviders(mock, testCpt),
        schemas: [core_1.CUSTOM_ELEMENTS_SCHEMA],
        declarations: [date_picker_1.DatePicker, navigator_1.Navigator, navigator_1.NavigatorItem, progress_view_1.ProgressView, segmented_control_1.SegmentedControl, tabbar_1.TabBar, tabbar_item_1.TabBarItem, testCpt].concat(declarations)
    });
    //
    return tb;
}
exports.configureTestingModule = configureTestingModule;
function initTest(testCpt, tpl) {
    testing_1.TestBed.overrideComponent(testCpt, { set: { template: tpl } });
    var rootRenderer = testing_1.getTestBed().get(renderer_1.ReactNativeRootRenderer);
    rootRenderer.zone = testing_1.getTestBed().get(core_1.NgZone);
    var fixture = testing_1.TestBed.createComponent(testCpt);
    fixture.autoDetectChanges();
    rootRenderer.executeCommands();
    return { fixture: fixture, rootRenderer: rootRenderer };
}
exports.initTest = initTest;
function getTestingProviders(mock, testCpt) {
    return [
        { provide: core_1.ApplicationRef, useClass: mock_application_ref_1.MockApplicationRef },
        { provide: common_1.LocationStrategy, useClass: location_strategy_1.ReactNativeLocationStrategy },
        { provide: renderer_1.REACT_NATIVE_WRAPPER, useValue: mock },
        renderer_1.ReactNativeElementSchemaRegistry,
        { provide: compiler_1.ElementSchemaRegistry, useExisting: renderer_1.ReactNativeElementSchemaRegistry },
        renderer_1.ReactNativeSanitizer,
        { provide: core_1.Sanitizer, useExisting: renderer_1.ReactNativeSanitizer },
        [renderer_1.ReactNativeRootRenderer],
        { provide: core_1.RendererFactory2, useExisting: renderer_1.ReactNativeRootRenderer }
    ];
}
function fireEvent(name, target, timeStamp, touches, changedIndices) {
    if (timeStamp === void 0) { timeStamp = 0; }
    if (touches === void 0) { touches = [[0, 0]]; }
    if (changedIndices === void 0) { changedIndices = [0]; }
    var t = [];
    for (var i = 0; i < touches.length; i++) {
        t.push({ clientX: touches[i][0], clientY: touches[i][1] });
    }
    var event = {
        type: name,
        clientX: touches[0][0],
        clientY: touches[0][1],
        touches: t,
        changedIndices: changedIndices,
        timeStamp: timeStamp,
        target: target,
        preventDefault: function () { },
        _stop: false
    };
    event['stopPropagation'] = function () {
        event._stop = true;
    };
    target.fireEvent(name, event);
}
exports.fireEvent = fireEvent;
function fireFunctionalEvent(name, target, data) {
    data._stop = true;
    data.type = name;
    data.target = target;
    target.fireEvent(name, data);
}
exports.fireFunctionalEvent = fireFunctionalEvent;
function fireGesture(name, target) {
    switch (name) {
        case 'tap':
            fireEvent('topTouchStart', target, 0);
            fireEvent('topTouchEnd', target, 10);
            break;
        case 'doubletap':
            fireEvent('topTouchStart', target, 0);
            fireEvent('topTouchEnd', target, 10);
            fireEvent('topTouchStart', target, 20);
            fireEvent('topTouchEnd', target, 30);
            break;
        case 'swipe':
            fireEvent('topTouchStart', target, 0, [[0, 0]]);
            fireEvent('topTouchMove', target, 10, [[25, 0]]);
            fireEvent('topTouchMove', target, 20, [[50, 0]]);
            fireEvent('topTouchMove', target, 30, [[75, 0]]);
            fireEvent('topTouchEnd', target, 40, [[100, 0]]);
            break;
    }
}
exports.fireGesture = fireGesture;
