import { ReactNativeWrapper } from "./wrapper";
export declare class Command {
    name: string;
    target: number;
    details: string;
    constructor(name: string, target: number, details: string);
    toString(): string;
}
export declare class MockReactNativeWrapper extends ReactNativeWrapper {
    commandLogs: Array<Command>;
    root: NativeElement;
    nativeElementMap: Map<number, NativeElement>;
    private _lastTagUsed;
    private _platform;
    constructor();
    reset(): void;
    clearLogs(): void;
    createView(tagName: string, root: number, properties: Object): number;
    updateView(tag: number, tagName: string, properties: any): void;
    manageChildren(parentTag: number, moveFrom: Array<number>, moveTo: Array<number>, addTags: Array<number>, addAt: Array<number>, removeFrom: Array<number>): void;
    dispatchCommand(tag: number, command: string, params?: any): void;
    computeStyle(styles: Array<any>): Object;
    patchReactNativeWithZone(zone: any): void;
    patchReactNativeEventEmitter(nodeMap: Map<number, any>): void;
    processColor(color: string): number;
    resolveAssetSource(source: any): any;
    dismissKeyboard(): void;
    requestNavigatorLock(tag: number, callback: (b: boolean) => any): void;
    getUIManager(): any;
    isAndroid(): boolean;
    blur(tag: number): void;
    focus(tag: number): void;
    setPlatform(platform: string): void;
    $log(...args: any[]): void;
}
export declare class NativeElement {
    name: string;
    tag: number;
    properties: {
        [s: string]: any;
    };
    children: Array<NativeElement>;
    parent: NativeElement;
    constructor(name: string, tag: number, properties: {
        [s: string]: any;
    });
    toString(shift?: number): string;
}
